searchData={"items":[{"type":"task","title":"mix workspace.check","doc":"Check the workspace using the configured checks.\n\n    $ mix workspace.check","ref":"Mix.Tasks.Workspace.Check.html"},{"type":"task","title":"Command Line Options - mix workspace.check","doc":"* `-c, --check...` (`atom`) - Specify a check `id` to be executed. If set only those checks will run.\nCan be set more than once.\n [values can be grouped with the `,` separator]","ref":"Mix.Tasks.Workspace.Check.html#module-command-line-options"},{"type":"task","title":"Filtering options - mix workspace.check","doc":"* `-e, --exclude...` (`string`) - Ignore the given projects [values can be grouped with the `,` separator]\n* `--exclude-tag...` (`string`) - If set, any projects with any of the given tag(s) will be excluded. For scoped tags you should\nprovide a colon separated string (examples: `shared`, `scope:api`, `type:utils`). For selecting\na specific tag use `--tag`\n [values can be grouped with the `,` separator]\n* `-p, --project...` (`string`) - The project name, can be defined multiple times. If not set all projects are considered [values can be grouped with the `,` separator]\n* `--tag...` (`string`) - If set, only projects with the given tag(s) will be considered. For scoped tags you should\nprovide a colon separated string (examples: `shared`, `scope:api`, `type:utils`). For\nexcluding a specific tag use `--exclude-tag`\n [values can be grouped with the `,` separator]","ref":"Mix.Tasks.Workspace.Check.html#module-filtering-options"},{"type":"task","title":"Display options - mix workspace.check","doc":"* `--verbose` (`boolean`) - If set enables verbose logging [default: `false`]","ref":"Mix.Tasks.Workspace.Check.html#module-display-options"},{"type":"task","title":"Global workspace options - mix workspace.check","doc":"* `--config-path` (`string`) - The path to the workspace config to be used, relative to the workspace path [default: `\".workspace.exs\"`]\n* `--workspace-path` (`string`) - If set it specifies the root workspace path, defaults to current directory","ref":"Mix.Tasks.Workspace.Check.html#module-global-workspace-options"},{"type":"task","title":"What to check - mix workspace.check","doc":"This depends on your codebase and your conventions. When your mono-repo\ngrows it is becoming more tedious to keep track with all projects and\nensure that the same standards apply to all projects.\n\nFor example you may wish to have common dependencies defined across all your\nprojects, or ensure that all packages have a valid maintainer set. Checks\nshould be used for verifying the high level conventions of your project and\nyour business rules.\n\n`Workspace` comes with some basic checks included that allow you among other to:\n\n* Ensure that specific dependencies are set through the `Workspace.Checks.EnsureDependencies` check.\n* Ensure that external dependencies versions match the expected ones through `Workspace.Checks.DependenciesVersion`.\n* Verify that no forbidden dependencies are defined through `Workspace.Checks.ForbiddenDeps`.\n* Validate arbitrarily the projects' config objects with `Workspace.Checks.ValidateProject`.\n* Enforce boundaries between workspace projects through `Workspace.Checks.EnforceBoundaries`.\n\nCheck `Workspace.Check` for more details on checks and a guide on how to implement\nyour custom check.","ref":"Mix.Tasks.Workspace.Check.html#module-what-to-check"},{"type":"task","title":"Checks config - mix workspace.check","doc":"All checks must be configured under the `:checks` option of your workspace\nconfig. You can use any of the officially supported checks or implement your\nown.\n\nHere is an example of some checks from the workspace repo:\n\n```elixir\nchecks: [\n  [\n    id: :description_set,\n    module: Workspace.Checks.ValidateProject,\n    description: \"all projects must have a description set\",\n    opts: [\n      validate: fn project ->\n        case project.config[:description] do\n          nil -> {:error, \"no :description set\"}\n          description when is_binary(description) -> {:ok, \"description set to #{description}\"}\n          other -> {:error, \"description must be binary, got: #{inspect(other)}\"}\n        end\n      end\n    ]\n  ],\n  [\n    id: :deps_path,\n    module: Workspace.Checks.ValidateConfigPath,\n    description: \"all projects must have a common dependencies path\",\n    opts: [\n      config_attribute: :deps_path,\n      expected_path: \"artifacts/deps\"\n    ]\n  ],\n]\n```","ref":"Mix.Tasks.Workspace.Check.html#module-checks-config"},{"type":"task","title":"Grouping checks - mix workspace.check","doc":"Checks can be organized in groups. Groups will be used by the task\nfor pretty printing a header followed by all relevant checks.\n\nThe `:group` can be set in the check definition:\n\n```elixir\nchecks: [\n  [\n    id: :description_set,\n    group: :package,\n    ...\n  ],\n  [\n    id: :valid_maintainers,\n    group: :package\n    ...\n  ]\n]\n```","ref":"Mix.Tasks.Workspace.Check.html#module-grouping-checks"},{"type":"task","title":"Groups headers styling - mix workspace.check","doc":"By default a yellow header will be added for each group with the\ngroup name as title. If you wish you can configure the styling and/or\nthe title of each group header through the `:groups_for_checks`\nconfiguration:\n\n```elixir\ngroups_for_checks: [\n  package: [\n    style: [:red]\n  ],\n  docs: [\n    title: \" 📚 Documentation checks\",\n    style: [:yellow_background, :white]\n  ]\n]\n```\n\nCheck `Workspace.Config` for more details.","ref":"Mix.Tasks.Workspace.Check.html#module-groups-headers-styling"},{"type":"task","title":"mix workspace.graph","doc":"Prints the workspace graph.\n\n    $ mix workspace.graph","ref":"Mix.Tasks.Workspace.Graph.html"},{"type":"task","title":"Formatters - mix workspace.graph","doc":"By default the graph will be pretty printed in the terminal:\n\n    $ mix workspace.graph\n    :api\n    ├── :accounts\n    │   └── :ecto_utils\n    ├── :cli_tools\n    └── :orders\n        ├── :string_utils\n        └── :warehouse\n            └── :ecto_utils\n    :back_office\n    └── :cli_tools\n\nYou can also format it as `mermaid` or `dot`:\n\n    $ mix workspace.graph --format dot\n    digraph G {\n      accounts -> ecto_utils;\n      api -> accounts;\n      api -> cli_tools;\n      api -> orders;\n      back_office -> cli_tools;\n      orders -> string_utils;\n      orders -> warehouse;\n      warehouse -> ecto_utils;\n    }","ref":"Mix.Tasks.Workspace.Graph.html#module-formatters"},{"type":"task","title":"Showing project's statuses - mix workspace.graph","doc":"If you pass the `--show-status` flag the project statuses are also\nincluded.\n\n    $ mix workspace.graph --show-status\n    :api ✚\n    ├── :accounts ✔\n    │   └── :ecto_utils ✔\n    ├── :cli_tools ✚\n    └── :orders ✔\n        ├── :string_utils ✔\n        └── :warehouse ✔\n            └── :ecto_utils ✔\n    :back_office ●\n    └── :cli_tools ✚\n\nThe following color coding is used:\n\n* Modified projects are shown in **red color**\n* Affected projects are shown in **orange color**","ref":"Mix.Tasks.Workspace.Graph.html#module-showing-project-s-statuses"},{"type":"task","title":"Focusing the graph around a project - mix workspace.graph","doc":"You can focus the graph around a single project by passing the `--focus`\noption.\n\n    $ mix workspace.graph --focus api\n    :api\n    ├── :accounts\n    ├── :cli_tools\n    └── :orders\n\nThis will print the graph around `cli_tools` including only it's children\nand parents that have a distance of 1 edge from it. You can widen the\npicture by setting the `--proximity` flag.","ref":"Mix.Tasks.Workspace.Graph.html#module-focusing-the-graph-around-a-project"},{"type":"task","title":"External dependencies - mix workspace.graph","doc":"By default only the workspace projects are included in the graph. You\ncan however include the external dependencies by passing the `--external`\nflag:\n\n    $ mix workspace.graph --external\n    :api\n    ├── :accounts\n    │   └── :ecto_utils\n    │       └── :poison (external)\n    ├── :cli_tools\n    └── :orders\n        ├── :string_utils\n        │   └── :ex_doc (external)\n        └── :warehouse\n            └── :ecto_utils\n    :back_office\n    └── :cli_tools","ref":"Mix.Tasks.Workspace.Graph.html#module-external-dependencies"},{"type":"task","title":"Command Line Options - mix workspace.graph","doc":"* `--external` (`boolean`) - If set external dependencies will also be inlcuded in the generated\ngraph.\n [default: `false`]\n* `--focus` (`string`) - If set the graph will be focused around the given project. Should be combined\nwith `:proximity` in order to define the depth of inward and outward neighbours\nto be displayed.\n* `--format` (`string`) - The output format of the graph. It can be one of the following:\n  * `pretty` - pretty prints the graph as a tree.\n  * `plain` - does not use Unicode code points for formatting the tree.\n  * `mermaid` - exports the graph as a mermaid graph.\n  * `dot` - produces a graphviz DOT graph description of the workspace.\n Allowed values: `[\"pretty\", \"plain\", \"mermaid\", \"dot\"]`. [default: `\"pretty\"`]\n* `--proximity` (`integer`) - The maximum allowed proximity between a graph's project and children or parent\nprojects. Only applicable if `:focus` is set.\n [default: `1`]","ref":"Mix.Tasks.Workspace.Graph.html#module-command-line-options"},{"type":"task","title":"Workspace status options - mix workspace.graph","doc":"Status is retrieved from the diff between the given `--base` and `--head`. Knowing the\nchanged files we can limit the execution of workspace commands only to relevant projects.\n\n\n* `--base` (`string`) - The base git reference to compare the head to. Applied only when `--affected` or `--modified`\nare set.\n* `--head` (`string`) - A reference to the git head. Applied only if `--base` is set for getting the changed files\n [default: `\"HEAD\"`]","ref":"Mix.Tasks.Workspace.Graph.html#module-workspace-status-options"},{"type":"task","title":"Filtering options - mix workspace.graph","doc":"* `-e, --exclude...` (`string`) - Ignore the given projects [values can be grouped with the `,` separator]","ref":"Mix.Tasks.Workspace.Graph.html#module-filtering-options"},{"type":"task","title":"Display options - mix workspace.graph","doc":"* `--show-status` (`boolean`) - If set the status of each project will be included in the output graph [default: `false`]\n* `--show-tags` (`boolean`) - If set the project's tags are also included in the generated graph. Currently\napplicable only for `:pretty` and `:plain` formatters.\n [default: `false`]","ref":"Mix.Tasks.Workspace.Graph.html#module-display-options"},{"type":"task","title":"Global workspace options - mix workspace.graph","doc":"* `--config-path` (`string`) - The path to the workspace config to be used, relative to the workspace path [default: `\".workspace.exs\"`]\n* `--workspace-path` (`string`) - If set it specifies the root workspace path, defaults to current directory","ref":"Mix.Tasks.Workspace.Graph.html#module-global-workspace-options"},{"type":"task","title":"mix workspace.list","doc":"Shows workspace project info\n\n    $ mix workspace.list\n\nBy default the following are displayed:\n\n- the project app name\n- the project path with respect to workspace path\n- the description if set\n- the project tags","ref":"Mix.Tasks.Workspace.List.html"},{"type":"task","title":"Command line options - mix workspace.list","doc":"","ref":"Mix.Tasks.Workspace.List.html#module-command-line-options"},{"type":"task","title":"Workspace status options - mix workspace.list","doc":"Status is retrieved from the diff between the given `--base` and `--head`. Knowing the\nchanged files we can limit the execution of workspace commands only to relevant projects.\n\n\n* `-a, --affected` (`boolean`) - Run only on affected projects [default: `false`]\n* `--base` (`string`) - The base git reference to compare the head to. Applied only when `--affected` or `--modified`\nare set.\n* `--head` (`string`) - A reference to the git head. Applied only if `--base` is set for getting the changed files\n [default: `\"HEAD\"`]\n* `-m, --modified` (`boolean`) - Run only on modified projects [default: `false`]","ref":"Mix.Tasks.Workspace.List.html#module-workspace-status-options"},{"type":"task","title":"Filtering options - mix workspace.list","doc":"* `--dependency` (`string`) - If set, only projects that have the given dependency will be considered.\n* `--dependent` (`string`) - If set, only projects that are dependencies of the given project are considered.\n* `-e, --exclude...` (`string`) - Ignore the given projects [values can be grouped with the `,` separator]\n* `--exclude-tag...` (`string`) - If set, any projects with any of the given tag(s) will be excluded. For scoped tags you should\nprovide a colon separated string (examples: `shared`, `scope:api`, `type:utils`). For selecting\na specific tag use `--tag`\n [values can be grouped with the `,` separator]\n* `--maintainer` (`string`) - Search for projects with the given maintainer. A partial case insensitive string search\nis performed so you can provide only part of the maintainer's name.\n* `--path...` (`string`) - A path under which projects will be considered. Paths should be relative with respect to\nthe workspace root. All other projects can be ignored. Can be set multiple times.\n* `-p, --project...` (`string`) - The project name, can be defined multiple times. If not set all projects are considered [values can be grouped with the `,` separator]\n* `--tag...` (`string`) - If set, only projects with the given tag(s) will be considered. For scoped tags you should\nprovide a colon separated string (examples: `shared`, `scope:api`, `type:utils`). For\nexcluding a specific tag use `--exclude-tag`\n [values can be grouped with the `,` separator]","ref":"Mix.Tasks.Workspace.List.html#module-filtering-options"},{"type":"task","title":"Display options - mix workspace.list","doc":"* `--show-status` (`boolean`) - If set the status of each project will be included in the output graph [default: `false`]","ref":"Mix.Tasks.Workspace.List.html#module-display-options"},{"type":"task","title":"Export options - mix workspace.list","doc":"* `--json` (`boolean`) - If set a `json` file will be generated with the list of workspace projects and\nassociated metadata. By default it will be saved in `workspace.json` in the\ncurrent directory. You can override the output path by setting the `--output`\noption.\n [default: `false`]\n* `--output` (`string`) - The output file. Applicable only if `--json` is set.\n [default: `\"workspace.json\"`]\n* `--relative-paths` (`boolean`) - If set the paths in the exported json file will be relative with respect to the\nworkspace path. Applicable only if `--json` is set.\n [default: `false`]","ref":"Mix.Tasks.Workspace.List.html#module-export-options"},{"type":"task","title":"Global workspace options - mix workspace.list","doc":"* `--config-path` (`string`) - The path to the workspace config to be used, relative to the workspace path [default: `\".workspace.exs\"`]\n* `--workspace-path` (`string`) - If set it specifies the root workspace path, defaults to current directory","ref":"Mix.Tasks.Workspace.List.html#module-global-workspace-options"},{"type":"task","title":"Filtering projects - mix workspace.list","doc":"Several command line options can limit the returned projects and filter the\nworkspace.\n\nYou can list only projects with a specific tag:\n\n    $ mix workspace.list --tag core\n\nOr exclude projects with a specific tag:\n\n    $ mix workspace.list --exclude-tag deprecated\n\nIf your monorepo has a nested structure you can list projects only under one or more\nspecific paths.\n\n    $ mix workspace.list --path packages/shared --path packages/infra\n\nIn large monorepos you may want to get all projects depending on a specific package. You\ncan achieve this through the `--dependency` option:\n\n    $ mix workspace.list --dependency foo\n\nAdditionally you can specify the `--dependent` flag to consider only dependencies of a\ngiven project:\n\n    $ mix workspace.list --dependent foo\n\nYou can also filter by the project's maintainer. The search is case insensitive. The\nmaintainers are expected to be defined under `package`:\n\n    def project do\n      [\n        package: [\n          maintainers: [\"Jack Sparrow\"]\n        ],\n        # rest project options\n      ]\n\nIn order to get all projects associated with a specific maintainer:\n\n    $ mix workspace.list --maintainer \"Jack Sparrow\"\n\n    # notice that the search is case insensitive, this works as well\n    $ mix workspace.list --maintainer sparrow","ref":"Mix.Tasks.Workspace.List.html#module-filtering-projects"},{"type":"task","title":"mix workspace.run","doc":"Run a mix task on one or more workspace projects.\n\nYou need to specify the task to be executed with the `--task, -t` option:\n\n    $ mix workspace.run -t format\n\nThis will run `mix format` on all projects of the workspace. You can also select\nthe projects to run, or exclude specific projects:\n\n    # Run format only on foo and bar\n    $ mix workspace.run -t format -p foo -p bar\n\n    # Run format on all projects except foo\n    $ mix workspace.run -t format -e foo","ref":"Mix.Tasks.Workspace.Run.html"},{"type":"task","title":"Passing options to tasks - mix workspace.run","doc":"You can pass task specific options after the return separator (`--`). For example:\n\n    $ mix workspace.run -t format -p foo -p bar -- --check-formatted","ref":"Mix.Tasks.Workspace.Run.html#module-passing-options-to-tasks"},{"type":"task","title":"Command-line Options - mix workspace.run","doc":"* `--allow-failure...` (`atom`) - Allow the task for this specific project to fail. Can be set more than once.\n [values can be grouped with the `,` separator]\n* `--dry-run` (`boolean`) - If set it will not execute the command, useful for testing and debugging. [default: `false`]\n* `--early-stop` (`boolean`) - If set the execution will stop if the execution of any project failed\n [default: `false`]\n* `--env-var...` (`string`) - Optional environment variables to be set before command execution. They are\nexpected to be in the form `ENV_VAR_NAME=value`. You can use this multiple times\nfor setting multiple variables.\n* `--order` (`string`) - The execution order based on the workspace graph. Can be one of the\nfollowing:\n\n* `alphabetical` - The projects are sorted alphabetically\n* `postorder` - Performs a depth-first search on the project graph and returns the\nprojects in post-order. In this order, outer leaves (projects without dependencies)\nare returned first, followed by their parent projects, respecting the dependency\nrelationships between them.\n Allowed values: `[\"alphabetical\", \"postorder\"]`. [default: `\"alphabetical\"`]\n* `--partitions` (`integer`) - Sets the number of partitions to split executions in. It must be a number\ngreater than zero. If set to `1` it acts as a no-op. If more than one you\nmust also set the the `WORKSPACE_RUN_PARTITION` environment variable with\nthe partition to use in the current execution. See the \"Run partitioning\"\nsection for more details\n* `-t, --task` (`string`) - Required. The task to execute","ref":"Mix.Tasks.Workspace.Run.html#module-command-line-options"},{"type":"task","title":"Workspace status options - mix workspace.run","doc":"Status is retrieved from the diff between the given `--base` and `--head`. Knowing the\nchanged files we can limit the execution of workspace commands only to relevant projects.\n\n\n* `-a, --affected` (`boolean`) - Run only on affected projects [default: `false`]\n* `--base` (`string`) - The base git reference to compare the head to. Applied only when `--affected` or `--modified`\nare set.\n* `--head` (`string`) - A reference to the git head. Applied only if `--base` is set for getting the changed files\n [default: `\"HEAD\"`]\n* `-m, --modified` (`boolean`) - Run only on modified projects [default: `false`]\n* `--only-roots` (`boolean`) - If set, the task will be executed only on graph's root nodes. [default: `false`]","ref":"Mix.Tasks.Workspace.Run.html#module-workspace-status-options"},{"type":"task","title":"Filtering options - mix workspace.run","doc":"* `--dependency` (`string`) - If set, only projects that have the given dependency will be considered.\n* `--dependent` (`string`) - If set, only projects that are dependencies of the given project are considered.\n* `-e, --exclude...` (`string`) - Ignore the given projects [values can be grouped with the `,` separator]\n* `--exclude-tag...` (`string`) - If set, any projects with any of the given tag(s) will be excluded. For scoped tags you should\nprovide a colon separated string (examples: `shared`, `scope:api`, `type:utils`). For selecting\na specific tag use `--tag`\n [values can be grouped with the `,` separator]\n* `--path...` (`string`) - A path under which projects will be considered. Paths should be relative with respect to\nthe workspace root. All other projects can be ignored. Can be set multiple times.\n* `-p, --project...` (`string`) - The project name, can be defined multiple times. If not set all projects are considered [values can be grouped with the `,` separator]\n* `--tag...` (`string`) - If set, only projects with the given tag(s) will be considered. For scoped tags you should\nprovide a colon separated string (examples: `shared`, `scope:api`, `type:utils`). For\nexcluding a specific tag use `--exclude-tag`\n [values can be grouped with the `,` separator]","ref":"Mix.Tasks.Workspace.Run.html#module-filtering-options"},{"type":"task","title":"Display options - mix workspace.run","doc":"* `--show-status` (`boolean`) - If set the status of each project will be included in the output graph [default: `false`]\n* `--verbose` (`boolean`) - If set enables verbose logging [default: `false`]","ref":"Mix.Tasks.Workspace.Run.html#module-display-options"},{"type":"task","title":"Export options - mix workspace.run","doc":"* `--export` (`string`) - A `json` path to export the run results. If set a `json` file will be\ngenerated with the run results for each project. This may be useful for\nyour CI/CD automation pipelines, in case you want to post-process the\nrun results.","ref":"Mix.Tasks.Workspace.Run.html#module-export-options"},{"type":"task","title":"Global workspace options - mix workspace.run","doc":"* `--config-path` (`string`) - The path to the workspace config to be used, relative to the workspace path [default: `\".workspace.exs\"`]\n* `--workspace-path` (`string`) - If set it specifies the root workspace path, defaults to current directory","ref":"Mix.Tasks.Workspace.Run.html#module-global-workspace-options"},{"type":"task","title":"Filtering runs - mix workspace.run","doc":"Monorepos can have hundreds of projects so being able to run a task against all\nor a subset of them is a key feature of Workspace.\n\nOne of the key features of `workspace.run` is the flexibility regarding the projects\non which the task will be executed.","ref":"Mix.Tasks.Workspace.Run.html#module-filtering-runs"},{"type":"task","title":"The project graph - mix workspace.run","doc":"The core concept of `Workspace` is the project graph. This is a directed acyclic\ngraphs depicting the internal project dependencies. This is used by all tasks\ninternally in order to specify the status of the projects.\n\nAssume you have the following workspace:\n\n```\npackage_a\n├── package_b ✚\n│   └── package_g\n├── package_c\n│   ├── package_e\n│   └── package_f\n│       └── package_g\n└── package_d\npackage_h ✚\n└── package_d\n```\n\nIt consists of various packages, and two of them (`_b` and `_h`) are modified. Using\nthe graph we can find the dependencies between packages and **limit the execution of\na task** only to the subset that makes sense.\n\n**Using the proper execution strategy wisely significantly improves the CI execution\ntime**.\n\n> #### Where to run a task? {: .tip}\n>\n> This clearly depends on the type of the task. Let's see some examples:\n>\n> - `mix format` makes sense to be executed only on the modified packages.\n> - `mix test` should be executed on the modified and the parents of them since a change\n> on a package may affect a dependent one.\n> - `mix deps.get` makes sense to be executed only on the root packages if\n> you have adopted a common deps path, since internal dependencies will be\n> inherited from dependent packages.\n> - In the main branch it makes sense to run the full suite on the\n> complete workspace.\n\nIn order to visualize the graph of the current workspace check the `mix workspace.graph`\ntask.","ref":"Mix.Tasks.Workspace.Run.html#module-the-project-graph"},{"type":"task","title":"Filtering examples - mix workspace.run","doc":"Let's see some examples:\n\n    # Run test on all workspace projects\n    $ mix workspace.run -t test\n\n    # Run test only on foo and bar\n    $ mix workspace.run -t test -p foo -p bar\n\n    # Run test on all projects excluding foo and bar\n    $ mix workspace.run -t test --exclude foo --exclude bar\n\n    # Run test on all affected projects\n    $ mix workspace.run -t test --affected\n\n    # Run test on all modified projects\n    $ mix workspace.run -t test --modified\n\n    # Run test only on top level projects\n    $ mix workspace.run -t test --only-roots","ref":"Mix.Tasks.Workspace.Run.html#module-filtering-examples"},{"type":"task","title":"Execution order - mix workspace.run","doc":"By default the given task will run on all projects (matching any provided filter) alphabetically\nwith respect to the project app name. You can also pass the `--order postorder` option\nwhich applies a topologic sort. This will perform a depth first search on the project graph\nand return the project in post-order, e.g. outer leaves are returned first respecting\nyour workspace graph.\n\n    $ mix workspace.run -t compile --order postorder\n\nThe `preorder` option ensures that dependencies are executed first, which can reduce\nexecution time by avoiding unnecessary task invocations on dependencies (only if the\ntask requires dependencies being executed first, e.g. `mix compile` with a common\nbuild path).","ref":"Mix.Tasks.Workspace.Run.html#module-execution-order"},{"type":"task","title":"Run partitioning - mix workspace.run","doc":"In big workspaces some CI steps may take a lot time. You can split the execution of\na task in multiple partitions in order to speed up this process. This is done by\nsetting the `--partitions` option and setting the `WORKSPACE_RUN_PARTITION` environment\nvariable to control the current partition.\n\nFor example to split the execution of `mix test` on all workspace projects into\n4 partitions, you would use the following:\n\n    $ WORKSPACE_RUN_PARTITION=1 mix workspace.run -t run --partitions 4\n    $ WORKSPACE_RUN_PARTITION=2 mix workspace.run -t run --partitions 4\n    $ WORKSPACE_RUN_PARTITION=3 mix workspace.run -t run --partitions 4\n    $ WORKSPACE_RUN_PARTITION=4 mix workspace.run -t run --partitions 4\n\nThe matching projects are sorted upfront and assigned to each partition in a round-robin\nfashion.","ref":"Mix.Tasks.Workspace.Run.html#module-run-partitioning"},{"type":"task","title":"The `--env-var` option - mix workspace.run","doc":"Some tasks depend on environment variables. You can use the `--env-var` option to\nset an environment variable only during a task's execution. This is particularly useful\nin CI environments.\n\n    $ mix workspace.run -t compile --env-var MIX_ENV=compile\n\nYou can set multiple environment variables by setting the `--env-var` multiple times.","ref":"Mix.Tasks.Workspace.Run.html#module-the-env-var-option"},{"type":"task","title":"Early stopping - mix workspace.run","doc":"You can set the `--early-stop` flag in order to immediately terminate the command if\nthe execution in any of the projects has failed.","ref":"Mix.Tasks.Workspace.Run.html#module-early-stopping"},{"type":"task","title":"Allowing failures on some projects - mix workspace.run","doc":"On big codebases not all projects are of the same quality standards and some linter\ntasks may fail on them. In such cases you may want to still run the linting tasks on\nthese projects but ignore their output status from the overall run task's status. In\nsuch cases you can use the `--allow-failure` option:\n\n    # Run lint on all projects but ignore the output status of project foo\n    $ mix workspace.run -t lint --allow-failure foo","ref":"Mix.Tasks.Workspace.Run.html#module-allowing-failures-on-some-projects"},{"type":"task","title":"Dry running a task - mix workspace.run","doc":"You can set the `--dry-run` option in order to dry run the task, e.g. to check the\nsequence of mix tasks that will be invoked.","ref":"Mix.Tasks.Workspace.Run.html#module-dry-running-a-task"},{"type":"task","title":"Exporting run results - mix workspace.run","doc":"You can set the `--export` option in order to save the run results per workspace\nproject in a `json` file. This may be useful in case you want to post-process run\nresults in your CI pipelines, for example you could use it to generate a summary\nof the execution and post it as a comment to the corresponding PR/MR.\n\n    # Exporting execution results to test.json\n    $ mix workspace.run -t test --export test.json\n\nFor each project the following will be included:\n\n* The project info\n* The executed task\n* The run's status (one of `\"ok\", error\", \"skip\"`)\n* Execution time info like the `triggered_at`, `completed_at` timestamps and the `duration`\n  of the task in milliseconds.\n* The task's status code\n* The task's output with ANSI sequences removed\n\nNotice that all workspace projects will be included in the generated `json` including\nthe skipped projects.","ref":"Mix.Tasks.Workspace.Run.html#module-exporting-run-results"},{"type":"task","title":"mix workspace.status","doc":"Similar to `git status` but on a workspace level.\n\n    $ mix workspace.status","ref":"Mix.Tasks.Workspace.Status.html"},{"type":"task","title":"Command line options - mix workspace.status","doc":"","ref":"Mix.Tasks.Workspace.Status.html#module-command-line-options"},{"type":"task","title":"Workspace status options - mix workspace.status","doc":"Status is retrieved from the diff between the given `--base` and `--head`. Knowing the\nchanged files we can limit the execution of workspace commands only to relevant projects.\n\n\n* `--base` (`string`) - The base git reference to compare the head to. Applied only when `--affected` or `--modified`\nare set.\n* `--head` (`string`) - A reference to the git head. Applied only if `--base` is set for getting the changed files\n [default: `\"HEAD\"`]","ref":"Mix.Tasks.Workspace.Status.html#module-workspace-status-options"},{"type":"task","title":"Global workspace options - mix workspace.status","doc":"* `--config-path` (`string`) - The path to the workspace config to be used, relative to the workspace path [default: `\".workspace.exs\"`]\n* `--workspace-path` (`string`) - If set it specifies the root workspace path, defaults to current directory","ref":"Mix.Tasks.Workspace.Status.html#module-global-workspace-options"},{"type":"task","title":"mix workspace.test.coverage","doc":"Analyze the test coverage of the workspace.\n\nYou can use it to generate test coverage for one or more projects of the\nworkspace. It will take care of finding the `coverdata` files, fixing the\nabsolute paths with respect to the workspace root and formatting the\nresults\n\n    $ mix workspace.test.coverage","ref":"Mix.Tasks.Workspace.Test.Coverage.html"},{"type":"task","title":"Invocation requirements - mix workspace.test.coverage","doc":"This task assumes that `mix test` has been executed with `--cover` and the\n`:export` option under `:test_coverage` set. It is advised to configure a\nworkspace check that ensures that all projects have these options properly\nset.\n\n```elixir\n[\n  module: Workspace.Checks.ValidateProject,\n  description: \"all projects must have test coverage export option set\",\n  opts: [\n    validate: fn config ->\n      coverage_opts = project.config[:test_coverage] || []\n      case coverage_opts[:export] do\n        nil -> {:error, \"export option not defined under :test_coverage settings\"}\n        _value -> {:ok, \"\"}\n      end\n    end\n  ]\n]\n```\n\n> #### Test coverage configuration best practices {: .tip}\n>\n> It is advised to set the test coverage `:output` for all workspace projects\n> pointing to the same directory with the application name set as prefix. This\n> way you can easily cache it in CI pipelines.\n>\n> A custom check can be used to ensure it:\n>\n> ```elixir \n> [\n>   module: Workspace.Checks.ValidateProject,\n>   description: \"all projects must have test_coverage[:output] properly set\",\n>   opts: [\n>     validate: fn project ->\n>       config = project.config\n>       coverage_opts = config[:test_coverage] || []\n>       output = coverage_opts[:output]\n>\n>       cond do\n>         is_nil(output) ->\n>           {:error, \":output option not defined under :test_coverage settings\"}\n>\n>         not String.ends_with?(output, Atom.to_string(config[:app])) ->\n>           {:error, \":output must point to a folder with the same name as the app name\"}\n>\n>         true ->\n>           {:ok, \"\"}\n>       end\n>     end\n>   ]\n> ]\n> ```\n>\n> And in your projects `mix.exs`:\n>\n> ```elixir\n> test_coverage: [\n>   output: \"path/to/common/app_name\"\n> ]\n> ```\n\n\nIn order to run the tests with `--cover` enabled for all workspace projects you\nshould run:\n\n    mix workspace.run -t test -- --cover","ref":"Mix.Tasks.Workspace.Test.Coverage.html#module-invocation-requirements"},{"type":"task","title":"Coverage thresholds - mix workspace.test.coverage","doc":"The task supports two coverage thresholds, the error threshold and the warning\nthreshold.\n\nThe error threshold can be configured by setting the `:threshold` option under\n`:test_coverage` on the project's config. If not set it defaults to `90%`. If\nany project has a coverage below the error threshold then **the command will fail**.\n\n> #### Allowing project failures {: .tip}\n>\n> When restructuring a large codebase some extracted projects will not have the\n> desired coverage. Instead of setting a very low threshold or adding tests\n> directly, you can explicitely allow these projects to fail. In order to do this\n> you have to set the `:allow_failure` flag of the `:test_coverage` workspace\n> settings. For example:\n>\n> ```elixir\n> test_coverage: [\n>   allow_failure: [:project_a, :project_b]\n>   ...\n> ]\n> ```\n>\n> In this case the error messages will be normally printed, but the exit code of\n> the command will not be affected.\n>\n> Notice that this does not affect the output and exit code `mix test --cover` if\n> executed directly in the project.\n\nWarning threshold can be configured by setting the `:warning_threshold` option. If\nnot set it defaults to `error_threshold + (100 - error_threshold)/2`. All project\nand module coverages that are below the warning threshold are logged as warnings.\n\nNotice that by default modules that have coverage above the warning threshold are\nnot logged. You can force the logging of all modules by setting the `--verbose`\nflag.\n\n> #### Workspace overall threshold {: .info}\n>\n> Similar to the individual project's coverage the overall test coverage is also\n> calculated on the workspace level.\n>\n> In order to specify error and warning thresholds you need to set the corresponding\n> options under the `:test_coverage` key of the workspace settings, for example:\n>\n> ```elixir\n> test_coverage: [\n>   threhsold: 70,\n>   warning_threshold: 95\n> ]\n> ```\n>\n> Notice that the overall coverage will be reported only for the projects which are\n> enabled on each invocation of the `mix workspace.test.coverage` task","ref":"Mix.Tasks.Workspace.Test.Coverage.html#module-coverage-thresholds"},{"type":"task","title":"Exporting coverage - mix workspace.test.coverage","doc":"By default the coverage results are not exported but only logged. You can however\nspecify one or more exporters in your workspace `:test_coverage` config. Each exporter\nis expected to be a function that accepts as input a workspace and a list of tuples\nof the form:\n\n```elixir\n{module :: module(), path :: binary(), function_data, line_data}\n```\n\nIt is responsible for processing the coverage data and generating a report in any format.\nOfficially we support the following exporters\n\n### `lcov` exporter \n\nGenerates an lcov file with both line and function coverage stats\n\n> #### Sample config {: .info}\n>  \n> ```elixir\n> test_coverage: [\n>   exporters: [\n>     lcov: fn workspace, coverage_stats -> \n>       Workspace.Coverage.export_lcov(\n>         workspace,\n>         coverage_stats,\n>         [output_path: \"artifacts/coverage\"]\n>       )\n>     end\n>   ]\n> ]\n> ```","ref":"Mix.Tasks.Workspace.Test.Coverage.html#module-exporting-coverage"},{"type":"task","title":"Command line options - mix workspace.test.coverage","doc":"","ref":"Mix.Tasks.Workspace.Test.Coverage.html#module-command-line-options"},{"type":"task","title":"Workspace status options - mix workspace.test.coverage","doc":"Status is retrieved from the diff between the given `--base` and `--head`. Knowing the\nchanged files we can limit the execution of workspace commands only to relevant projects.\n\n\n* `-a, --affected` (`boolean`) - Run only on affected projects [default: `false`]\n* `--base` (`string`) - The base git reference to compare the head to. Applied only when `--affected` or `--modified`\nare set.\n* `--head` (`string`) - A reference to the git head. Applied only if `--base` is set for getting the changed files\n [default: `\"HEAD\"`]\n* `-m, --modified` (`boolean`) - Run only on modified projects [default: `false`]","ref":"Mix.Tasks.Workspace.Test.Coverage.html#module-workspace-status-options"},{"type":"task","title":"Filtering options - mix workspace.test.coverage","doc":"* `-e, --exclude...` (`string`) - Ignore the given projects [values can be grouped with the `,` separator]\n* `--exclude-tag...` (`string`) - If set, any projects with any of the given tag(s) will be excluded. For scoped tags you should\nprovide a colon separated string (examples: `shared`, `scope:api`, `type:utils`). For selecting\na specific tag use `--tag`\n [values can be grouped with the `,` separator]\n* `--path...` (`string`) - A path under which projects will be considered. Paths should be relative with respect to\nthe workspace root. All other projects can be ignored. Can be set multiple times.\n* `-p, --project...` (`string`) - The project name, can be defined multiple times. If not set all projects are considered [values can be grouped with the `,` separator]\n* `--tag...` (`string`) - If set, only projects with the given tag(s) will be considered. For scoped tags you should\nprovide a colon separated string (examples: `shared`, `scope:api`, `type:utils`). For\nexcluding a specific tag use `--exclude-tag`\n [values can be grouped with the `,` separator]","ref":"Mix.Tasks.Workspace.Test.Coverage.html#module-filtering-options"},{"type":"task","title":"Display options - mix workspace.test.coverage","doc":"* `--silent` (`boolean`) - If set to true only the package coverage is reported and not the individual modules\ncoverages. This has higher priority than the `:verbose` option.\n [default: `false`]\n* `--verbose` (`boolean`) - If set enables verbose logging [default: `false`]","ref":"Mix.Tasks.Workspace.Test.Coverage.html#module-display-options"},{"type":"task","title":"Global workspace options - mix workspace.test.coverage","doc":"* `--config-path` (`string`) - The path to the workspace config to be used, relative to the workspace path [default: `\".workspace.exs\"`]\n* `--workspace-path` (`string`) - If set it specifies the root workspace path, defaults to current directory","ref":"Mix.Tasks.Workspace.Test.Coverage.html#module-global-workspace-options"},{"type":"module","title":"Workspace","doc":"A `Workspace` is a collection of mix projects under the same git repo.\n\n`Workspace` provides a set of tools for working with multiple projects under\nthe same git repo. Using path dependencies between the projects and the\nprovided tools you can effectively work on massive codebases properly\nsplit into reusable packages.","ref":"Workspace.html"},{"type":"module","title":"Structuring a folder as a workspace root - Workspace","doc":"A workspace is a normal `Mix.Project` with some tweaks:\n\n  * No actual code is expected, so `:elixirc_paths` is set to `[]`\n  * It must have a `:workspace` project option configured with a `:type` set\n  to `:workspace`.\n\n```elixir\ndef project do\n  [\n    workspace: [\n      type: :workspace,\n      # arbitrary options can be set there\n    ],\n    # rest Mix.Project settings\n  ]\nend\n```\n\nA generator is provided for bootstrapping a new workspace project:\n\n    $ mix workspace.new NAME","ref":"Workspace.html#module-structuring-a-folder-as-a-workspace-root"},{"type":"module","title":"Workspace projects - Workspace","doc":"A mix project is considered a workspace project if:\n\n  * it is located in a subfolder of the workspace root path\n  * it is not included in the ignored projects or ignored paths in the\n  workspace config\n\nAssuming the folder structure:\n\n```\nmy_workspace\n├── apps\n│   ├── api         # an API app \n│   └── ui          # the UI project\n├── mix.exs         # this is the workspace root definition\n├── .workspace.exs  # the workspace config\n└── packages        # various reusable packages under packages\n    ├── package_a \n    ├── package_b\n    └── package_c\n```\n\nIn the above example:\n\n  * We have defined a `Workspace` under `my_workspace` folder\n  * All mix projects under `my_workspace` are by default considered\n  workspace packages. In the above example it will include the\n  `:api`, `:ui`, `:package_a`, `:package_b` and `:package_c`\n  packages.\n\n> #### Ignoring a package or a path {: .info}\n>\n> Assume you want to exclude `package_c` from the workspace. You\n> can add it to the `:ignore_projects` configuration option in\n> `.workspace.exs`:\n>\n> ```elixir\n> ignore_projects: [:package_a]\n> ```\n>\n> If you wanted to ignore all projects under an `other` folder\n> you could set the `:ignore_paths` option:\n>\n> ```elixir\n> ignore_paths: [\"other\"]\n> ```\n>\n> Notice that in the latter case the path is assumed to be relative to\n> the workspace root.\n>\n> For more details check the `Workspace.Config` documentation.\n\n> #### Duplicate package names {: .warning}\n>\n> Notice that duplicate package names are not allowed. If upon initialization\n> of a workspace two projects with the same `:name` are detected then\n> an exception will be raised.\n>\n> For example the following workspace:\n> \n> ```\n> my_workspace\n> ├── apps\n> │   └── api\n> ├── mix.exs\n> ├── packages\n> │   ├── package_a  # package_a project defined under packages\n> │   └── package_b\n> └── shared\n>     └── package_a  # redefinition of package_a\n> ```\n>\n> would fail to initialize since `:package_a` is defined twice.","ref":"Workspace.html#module-workspace-projects"},{"type":"module","title":"Loading a workspace - Workspace","doc":"A `Workspace` can be constructed by calling the `new/2` function. It\nwill use the given path and config object in order to load and validate\nall internal projects.","ref":"Workspace.html#module-loading-a-workspace"},{"type":"module","title":"The workspace graph - Workspace","doc":"The most important concept of the `Workspace` is the projects graph. The\nproject graph is a directed acyclic graph where each vertex is a project\nand each edge a dependency between the two projects.\n\nThe workspace graph is constructed implicitly upon workspace's creation\nin order to ensure that all path dependencies are valid and decorate\neach project with graph metadata.\n\n> #### Inspecting the graph {: .tip}\n> \n> You can use the `workspace.graph` command in order to see the\n> graph of the given `workspace`. For example:\n>\n> ```bash\n> mix workspace.graph --workspace-path test/fixtures/sample_workspace\n> ```\n>\n> on a test fixture would produce:\n>\n> ```\n> package_a\n> ├── package_b\n> │   └── package_g\n> ├── package_c\n> │   ├── package_e\n> │   └── package_f\n> │       └── package_g\n> └── package_d\n> package_h\n> └── package_d\n> package_i\n> └── package_j\n> package_k\n> ```\n>\n> You can additionally plot is as mermaid graph by specifying the\n> `--format mermaid` flag:\n>\n> ```mermaid\n> flowchart TD\n> package_a\n> package_b\n> package_c\n> package_d\n> package_e\n> package_f\n> package_g\n> package_h\n> package_i\n> package_j\n> package_k\n>\n> package_a --> package_b\n> package_a --> package_c\n> package_a --> package_d\n> package_b --> package_g\n> package_c --> package_e\n> package_c --> package_f\n> package_f --> package_g\n> package_h --> package_d\n> package_i --> package_j\n> ```","ref":"Workspace.html#module-the-workspace-graph"},{"type":"module","title":"Workspace filtering - Workspace","doc":"As your workspace grows running a CI task on all projects becomes too slow.\nTo address this, code change analysis is supported in order to get the minimum\nset of projects that need to be executed.\n\n`Workspace` supports various filtering modes. Each one should be used in\ncontext with the underlying task. For more details check `filter/2`.","ref":"Workspace.html#module-workspace-filtering"},{"type":"module","title":"Global filtering options - Workspace","doc":"* `:ignored` - ignores these specific projects\n  * `:selected` - considers only these projects\n  * `:only_roots` - considers only the graph roots (sources), e.g. ignores\n  all projects that have a parent in the graph.","ref":"Workspace.html#module-global-filtering-options"},{"type":"module","title":"Code analysis related options - Workspace","doc":"* `:modified` - returns only the modified projects, e.g. projects for which\n  the code has changed\n  * `:affected` - returns all affected projects. Affected projects are the\n  modified ones plus the \n\n`:modified` and `:affected` can be combined with the global filtering options.\n\n> #### Understanding when and how to filter a workspace {: .info}\n>\n> Workspace filtering should be actively used on big workspaces in order to\n> improve the local build and CI times.\n>\n> Some examples follow:\n>\n>   - If a workspace is used by multiple teams and contains multiple apps, you\n> should select a specific top level app when building the project. This will\n> ignore all other irrelevant apps.\n>   - When changing a specific set of projects, you should use `:modified` for\n> formatting the code since everything else is not affected. \n>   - Similarly for testing you should use the `:affected` filtering since a\n> change on a project may affect all parents.\n>   - It is advised to have generic CI pipelines on master/main branches that\n> do not apply any filtering.\n\n> #### Visualizing what is affected {: .tip}\n>\n> You can use the `--show-status` flag in most of `workspace` commands to indicate\n> what is unchanged, modified or affected.\n>\n> For instance if you have changed `package_f` and `package_d` you can visualize\n> the graph using `workspace.graph --format mermaid --show-status`\n>\n> ```mermaid\n> flowchart TD\n>   package_a\n>   package_b\n>   package_c\n>   package_d\n>   package_e\n>   package_f\n>   package_g\n>   package_h\n>   package_i\n>\n>   package_a --> package_b\n>   package_a --> package_c\n>   package_a --> package_d\n>   package_b --> package_g\n>   package_c --> package_e\n>   package_c --> package_f\n>   package_f --> package_g\n>   package_h --> package_d\n>   package_i --> package_b\n>\n>   class package_a affected;\n>   class package_c affected;\n>   class package_d modified;\n>   class package_f modified;\n>   class package_h affected;\n>\n>   classDef affected fill:#FA6,color:#FFF;\n>   classDef modified fill:#F33,color:#FFF;\n> ```\n> \n> Modified projects are indicated with red colors, and affected projects are\n> highlighted with orange color.\n>\n> You could now use the proper filtering flags based on what you want to run:\n>\n> ```bash\n> # We want to build only the top level affected projects\n> mix workspace.run -t compile --only-roots --affected\n>\n> # we want to format only the modified ones\n> mix workspace.run -t format --modified\n>\n> # we want to test all the affected ones\n> mix workspace.run -t test --affected\n> ```","ref":"Workspace.html#module-code-analysis-related-options"},{"type":"module","title":"Environment variables - Workspace","doc":"The following environment variables are supported:\n\n* `WORKSPACE_DEBUG` - if set then debug information will be printed.\n\nEnvironment variables that are not meant to hold a value (and act basically as\nflags) should be set to either `1` or `true`, for example:\n\n    $ WORKSPACE_DEBUG=true mix workspace.check","ref":"Workspace.html#module-environment-variables"},{"type":"module","title":"Multiple workspaces under the same git repo - Workspace","doc":"You can have multiple workspaces under the same git repo with the only constraint\nthat they cannot be nested.\n\n> #### Nested workspaces {: .warning}\n>\n> Notice that nested workspaces are not allowed, for example if you\n> have the following structure:\n>\n> ```bash\n> workspace\n> ├── .workspace.exs\n> ├── another_workspace\n> │   ├── .workspace.exs\n> │   └── mix.exs\n> └── mix.exs\n> ```\n>\n> an error will be raised.\n\nThis may be useful if you have a monorepo with various projects that have different\ndependencies and/or different teams managing them with different policies.\n\nFor example, assuming a git repo under `my-repo` you could create as many workspaces as\nyou wish:\n\n```bash\n$ cd my-repo\n$ mix workspace.new common\n$ mix workspace.new backend\n$ mix workspace.new frontend/app_a\n```\n\n> #### Isolated workspaces {: .info}\n>\n> Each workspace is treated in isolation, e.g. changes on workspace `common` do not\n> affect the status of workspace `backend`, even if there are path dependencies\n> between the two workspaces.\n\n> #### Running workspace commands from the root of the repo {: .tip}\n>\n> If you wish you can install `workspace` at the root, and install commands from\n> there, specifying the workspace path. This way you will not have to `cd` into the\n> different workspaces, improving the developer experience.\n>\n> You will need a minimal `mix.exs` at the root for istalling `workspace`:\n>\n>\n> ```elixir\n> defmodule Root.MixWorkspace do\n>   use Mix.Project\n>\n>   def project do\n>     [\n>       app: :root,\n>       version: \"0.2.0\",\n>       elixir: \"~> 1.15\",\n>       start_permanent: Mix.env() == :prod,\n>       deps: deps(),\n>       elixirc_paths: []\n>     ]\n>   end\n>\n>   def application do\n>     [\n>       extra_applications: []\n>     ]\n>   end\n>\n>   defp deps do\n>     [\n>       {:workspace, \"~> 0.2\"}\n>     ]\n>   end\n> end\n> ```\n>\n> Now from the root you can run workspace commands on any workspace:\n>\n> ```bash\n> $ mix workspace.list --workspace-path common\n> $ mix workspace.status --workspace-path frontend/app_a\n> ```","ref":"Workspace.html#module-multiple-workspaces-under-the-same-git-repo"},{"type":"function","title":"Workspace.new/2","doc":"Creates a new `Workspace` from the given workspace path\n\n`config_or_path` can be one of the following:\n\n  * A path relative to the workspace root path pointing to the workspace config\n  (`.workspace.exs` in most cases)\n  * A keyword list with the config\n\nThe workspace is created by finding all valid mix projects under\nthe workspace root.\n\nReturns `{:ok, workspace}` in case of success, or `{:error, reason}`\nif something fails.","ref":"Workspace.html#new/2"},{"type":"function","title":"Workspace.new!/2","doc":"Similar to `new/2` but raises in case of error.","ref":"Workspace.html#new!/2"},{"type":"function","title":"Workspace.project/2","doc":"Get the given project from the workspace.\n\nIf the project is not a workspace member, an error tuple is returned.","ref":"Workspace.html#project/2"},{"type":"function","title":"Workspace.project!/2","doc":"Similar to `project/2` but raises in case of error","ref":"Workspace.html#project!/2"},{"type":"function","title":"Workspace.project?/2","doc":"Returns `true` if the given `app` is a `workspace` project, `false` otherwise.","ref":"Workspace.html#project?/2"},{"type":"function","title":"Workspace.projects/2","doc":"Returns the workspace projects as a list.","ref":"Workspace.html#projects/2"},{"type":"function","title":"Options - Workspace.projects/2","doc":"* `:order` - Specifies the order in which the projects list will be returned. It can be\n  one of the following:\n  * `:alphabetical` - Sorts the projects by their application names in ascending order.\n  * `:postorder` - Performs a depth-first search on the project graph and returns the projects\n  in post-order. In this order, outer leaves (projects without dependencies) are returned\n  first, followed by their parent projects, respecting the dependency relationships between\n  them.\n  * If not specified, the projects will be returned in their original order without any\n  sorting.\n\n  For example for the following workspace graph:\n\n  ```mermaid\n  flowchart TD\n  zoo\n  bar\n  foo\n  baz\n\n  zoo --> bar\n  zoo --> foo\n  foo --> baz\n  bar --> baz\n  ```\n\n  we would get the following:\n\n  ```elixir\n  Workspace.projects(workspace, order: :alphabetical) # [:bar, :baz, :foo, :zoo]\n\n  # with :postorder set the packages are returned bottom to top respecting\n  # dependencies, notice this is not deterministic, e.g. you could also get\n  # [:baz, :bar, :foo, :zoo]\n  Workspace.projects(workspace, order: :postorder)    # [:baz, :foo, :bar, :zoo]\n  ```","ref":"Workspace.html#projects/2-options"},{"type":"module","title":"Workspace.Config","doc":"The workspace configuration.\n\nThe workspace configuration is specified usually in a `.workspace.exs` file in the\nroot of your workspace. This is the place to:\n\n  * Configure your workspace checks (`Workspace.Check`)\n  * Specify paths or projects to be ignored during the workspace graph generation\n  * Define overall workspace coverage thresholds\n  * Define any other configuration option may be needed by a third party plugin.\n\nIt is expected to be a keyword list with an arbitrary set of configuration options.","ref":"Workspace.Config.html"},{"type":"module","title":"Options - Workspace.Config","doc":"The following configuration options are supported by default:\n\n* `:ignore_projects` (list of `t:atom/0`) - A list of project modules to be ignored. If set these projects will\n  not be considered workspace projects when initializing a `Workspace`\n  with the current config. The default value is `[]`.\n\n* `:ignore_paths` (list of `t:String.t/0`) - List of paths relative to the workspace root to be ignored from\n  parsing for projects detection. The default value is `[]`.\n\n* `:checks` (list of `t:keyword/0`) - List of checks configured for the workspace. For more details check\n  `Workspace.Check` The default value is `[]`.\n\n* `:groups_for_checks` (non-empty `t:keyword/0`) - Allows you to configure the look and feel of the checks group headings.\n  It expects a keyword list, where the key is the group identifier and the\n  value is the configuration for this specific group heading, for example:\n\n  ```elixir\n  groups_for_checks: [\n    package: [\n      title: \"-> Package checks\",\n      style: [:red]\n    ],\n    docs: [\n      title: \" 📚 Documentation checks\",\n      style: [:yellow_background, :white]\n    ]\n  ]\n  ```\n\n  Each group style definition is expected to be a keyword list with the\n  following options:\n\n  * `:title` (`t:String.t/0`) - The title of the check group, if not set defaults to the group name\n\n  * `:style` (list of `t:atom/0`) - The ANSI style for the group heading. You can use it to modify the look\n    of this specific header. For example in order to make the background blue\n    and the text red you can set the style to:\n\n    ```elixir\n    style: [:blue_background, :red]\n    ```\n\n    For more details check the `IO.ANSI` docs.\n\n* `:test_coverage` (`t:keyword/0`) - Test coverage configuration for the workspace. Notice that this is\n  independent of the `test_coverage` configuration per project. It is\n  applied in the aggregate coverage and except thresholds you can\n  also configure coverage exporters. The default value is `[]`.\n\n  * `:threshold` (`t:non_neg_integer/0`) - The overall coverage threshold for the workspace. If the overall test coverage is below this\n    value then the `workspace.test.coverage` command is considered failed. Notice\n    that the overall test coverage percentage is calculated only on the enabled projects. The default value is `90`.\n\n  * `:warning_threshold` (`t:non_neg_integer/0`) - If set it specifies an overall warning threshold under which a warning will be\n    raised. If not set it is implied to be the mid value between `threshold` and `100`.\n\n  * `:exporters` (`t:keyword/0`) - Definition of exporters to be used. Each defined exporter must be an anonymous\n    function taking as input the `workspace` and the `coverage_stats`. For more\n    details check the `Mix.Tasks.Workspace.Test.Coverage` task.\n\n  * `:allow_failure` (list of `t:atom/0`) - A list of projects for which the test coverage is allowed to fail without affecting\n    the overall status. The default value is `[]`.\n\n\n\nA simple example of a `.workspace.exs` follows:\n\n```elixir\n[\n  ignore_paths: [\"deps\", \"artifacts\", \"cover\"],\n  checks: [\n    # Add your checks here\n    [\n      module: Workspace.Checks.ValidateProject,\n      description: \"all projects must have a description set\",\n      opts: [\n        validate: fn project ->\n          case project.config[:description] do\n            nil -> {:error, \"no :description set\"}\n            description when is_binary(description) -> {:ok, \"\"}\n            other -> {:error, \"description must be binary, got: #{inspect(other)}\"}\n          end\n        end\n      ]\n    ]\n  ],\n  test_coverage: [\n    allow_failure: [:foo],\n    threshold: 98,\n    warning_threshold: 99,\n    exporters: [\n      lcov: fn workspace, coverage_stats ->\n        Workspace.Coverage.LCOV.export(workspace, coverage_stats,\n          output_path: \"artifacts/coverage\"\n        )\n      end\n    ]\n  ],\n  my_awesome_plugin_options: [\n    x: 1,\n    y: 2\n  ]\n]\n```\n\n\n> #### Extra Options {: .info}\n>\n> Notice that the validation will **not fail** if any extra configuration option\n> is present. This way various plugins or mix tasks may define their own options\n> that can be read from this configuration.","ref":"Workspace.Config.html#module-options"},{"type":"function","title":"Workspace.Config.load/1","doc":"Loads the workspace config from the given path.\n\nAn error tuple will be returned if the config is invalid.","ref":"Workspace.Config.html#load/1"},{"type":"function","title":"Workspace.Config.validate/1","doc":"Validates that the given `config` is a valid `Workspace` config.\n\nA `config` is valid if:\n\n- it follows the workspace config schema\n- every check configuration is valid according to it's own schema. For more details\ncheck `Workspace.Check.validate/1`.\n\nReturns either `{:ok, config}` with the updated `config` is it is valid, or\n`{:error, message}` in case of errors.\n\nNotice that only the default options are validated, since the config may be used by\nplugins for setting custom options.","ref":"Workspace.Config.html#validate/1"},{"type":"function","title":"Workspace.Config.validate!/1","doc":"Same as `validate/1` but raises an `ArgumentError` exception in case of failure.\n\nIn case of success the validated configuration keyword list is returned.","ref":"Workspace.Config.html#validate!/1"},{"type":"module","title":"Workspace.Filtering","doc":"The workspace filtering logic.\n\nMost workspace tasks support various filtering methods, like\nexcluding specific projects, including only projects with\nspecific tags or with a specific modification status among other.\n\nThis module provides all filtering related functionality.","ref":"Workspace.Filtering.html"},{"type":"function","title":"Workspace.Filtering.run/2","doc":"Filter the `workspace` projects based on the given options.\n\nIt will iterate over all projects and wil set the `:skip` to `true` if the\nproject is considered skippable. The decision is made based on the provided\noptions.\n\nA `Workspace.State` is returned with the projects updated.","ref":"Workspace.Filtering.html#run/2"},{"type":"function","title":"Options - Workspace.Filtering.run/2","doc":"* `:exclude` (list of `t:atom/0`) - a list of projects to be ignored. This has\n  the highest priority, e.g. if the project is in the `:ignore` list it is\n  always skipped.\n  * `:exclude_tags` (list of `t:Workspace.Project.tag()`) - a list of tags to be\n  ignored. Any project that has any of the provided tags will be skipped.\n  * `:project` (list of `t:atom/0`) - a list of projects to consider. If set all\n  projects that are not included in the list are considered skippable.\n  * `:tags` (list of `t:Workspace.Project.tag()`) - a list of tags to be\n  considered. All projects that do not have at least one the specified tags will\n  be skipped.\n  * `:paths` (list of `t:String.t()`) - a list of project paths to be considered.\n  Only projects located under any of the provided path will be considered.\n  * `:dependency` (`t:atom/0`) - keeps only projects that have the given dependency.\n  * `:dependent` (`t:atom/0`) - keeps only dependencies of the given project.\n  * `:affected` (`t:boolean/0`) - if set only the affected projects will be\n  included and everything else will be skipped. Defaults to `false`.\n  * `:modified` (`t:boolean/0`) - if set only the modified projects will be\n  included. A project is considered modified if any file under the project's\n  root (excluding files in the `.gitignore`) has changed. Defaults to `false`.\n  * `:only_roots` (`t:boolean/0`) - if set only the root projects will be\n  included and everything else will be skipped. Defaults to `false`.\n  * `:base` (`t:String.t/0`) - The base git reference for detecting changed files,\n  If not set only working tree changes will be included.\n  * `:head` (`t:String.t/0`) - The head git reference for detecting changed files.\n  It is used only if `:base` is set.\n\n> #### Filtering order {: .neutral}\n> \n> Notice that projects are filtered using the following precedence:\n>\n> * Excluded projects (`:exclude` or `:exclude_tags` options set)\n> * Selected projects (`:project` or `:tags` option set)\n> * Code status modifiers (`:affected`, `:modified` and `:only_roots`)","ref":"Workspace.Filtering.html#run/2-options"},{"type":"module","title":"Workspace.Graph","doc":"Workspace path dependencies graph and helper utilities\n\n> #### Internal graph representation {: .neutral}\n>\n> Each graph node is an internal struct, holding the project name, the type\n> of the project (e.g. workspace or external dependency) and an arbitrary\n> set of metadata.\n\nBy default `:workspace` dependencies will always be included in the graph. On the\nother hand `:external` dependencies will be included only if the `:external`\noption is set to `true` during graph's construction.","ref":"Workspace.Graph.html"},{"type":"module","title":"Usage - Workspace.Graph","doc":"This module provides `with_digraph/3` and `digraph/2` for constructing the\nworkspace graph from a workspace, and a set of helper utilities operating\non a graph.\n\n    workspace = Workspace.new!(\"/path/to/workspace\")\n\n    # construct the graph, including external dependencies\n    graph = Workspace.Graph.digraph(workspace, external: true)\n\n    # get graph leaves\n    Workspace.Graph.sink_projects(graph)","ref":"Workspace.Graph.html#module-usage"},{"type":"function","title":"Workspace.Graph.affected/2","doc":"Get the affected workspace's projects given the changed `projects`\n\nNotice that the project names are returned, you can use `Workspace.project/2`\nto map them back into projects.","ref":"Workspace.Graph.html#affected/2"},{"type":"function","title":"Workspace.Graph.dependencies/2","doc":"Returns the direct dependencies of the given `project`\n\nThe direct dependencies are the path dependencies that are defined in the\n`project`' s `mix.exs`.","ref":"Workspace.Graph.html#dependencies/2"},{"type":"function","title":"Workspace.Graph.digraph/2","doc":"Generates a graph of the given workspace.\n\nNotice that you need to manually delete the graph. Prefer instead\n`with_digraph/3`.","ref":"Workspace.Graph.html#digraph/2"},{"type":"function","title":"Options - Workspace.Graph.digraph/2","doc":"* `:external` - if set external dependencies will be included as well\n  * `:exclude` - if set the specified workspace projects will not be included\n  in the graph","ref":"Workspace.Graph.html#digraph/2-options"},{"type":"function","title":"Workspace.Graph.sink_projects/1","doc":"Return the sink projects of the workspace\n\nNotice that the project names are returned, you can use `Workspace.project/2`\nto map them back into projects.","ref":"Workspace.Graph.html#sink_projects/1"},{"type":"function","title":"Workspace.Graph.source_projects/1","doc":"Return the source projects of the workspace\n\nThe input can be either a `Workspace` struct or the workspace graph. In case of a\n`Workspace` a temporary graph will be constructed.\n\nNotice that the project names are returned, you can use `Workspace.project/2`\nto map them back into projects.","ref":"Workspace.Graph.html#source_projects/1"},{"type":"function","title":"Workspace.Graph.subgraph/3","doc":"Returns a subgraph around the given `project` and all nodes within the given `proximity`.","ref":"Workspace.Graph.html#subgraph/3"},{"type":"type","title":"Workspace.Graph.vertices/0","doc":"","ref":"Workspace.Graph.html#t:vertices/0"},{"type":"function","title":"Workspace.Graph.with_digraph/3","doc":"Runs the given `callback` on the workspace's graph\n\n`callback` should be a function expecting as input a `:digraph.graph()`. For\nsupported options check `digraph/2`","ref":"Workspace.Graph.html#with_digraph/3"},{"type":"behaviour","title":"Workspace.Graph.Formatter","doc":"A behaviour for defining custom formatters for using with `mix workspace.graph`.\n\nA formatter is responsible for visualizing the workpsace graph.","ref":"Workspace.Graph.Formatter.html"},{"type":"function","title":"Workspace.Graph.Formatter.format/3","doc":"Formats the given workspace using the provided `formatter` and options.","ref":"Workspace.Graph.Formatter.html#format/3"},{"type":"function","title":"Options - Workspace.Graph.Formatter.format/3","doc":"","ref":"Workspace.Graph.Formatter.html#format/3-options"},{"type":"type","title":"Workspace.Graph.Formatter.formatter/0","doc":"A module implementing the `Workspace.Graph.Formatter` behaviour.","ref":"Workspace.Graph.Formatter.html#t:formatter/0"},{"type":"callback","title":"Workspace.Graph.Formatter.render/3","doc":"Renders the given workspace graph.\n\nThe formatter is responsible for printing any console output or generating any\noutput file, based on the given `opts`.\n\nThe `graph` is expected to be the `:digraph.graph()` to be printed. The graph may\nbe a subgraph of the full workspace graph.\n\nOptions are arbitrary and any formatter can support custom options.","ref":"Workspace.Graph.Formatter.html#c:render/3"},{"type":"module","title":"Workspace.Project","doc":"A struct holding a workspace project info.","ref":"Workspace.Project.html"},{"type":"module","title":"Workspace project config - Workspace.Project","doc":"Each workspace project may optionally have some workspace related settings defined\nin it's `Mix.Project` config. There isn't a comprehensive list of all supported\noptions since various plugins or mix tasks may define their own options that can\nbe read from this configuration.\n\nThe following are the global workspace supported settings:\n\n* `:tags` - Tags associated with the current project. A single tags can be either\n  an `atom` or a tuple of the form `{atom, atom}`. In the latter case\n  this is considered a scoped tag. For example:\n\n  ```elixir\n  tags: [:utils, {:scope, :shared}]\n  ```\n\n  The default value is `[]`.","ref":"Workspace.Project.html#module-workspace-project-config"},{"type":"function","title":"Workspace.Project.affected/1","doc":"Marks the given project as `:affected`.\n\nA project is considered affected if any of it's dependencies (either\ndirect or indirect) is modified.\n\nNotice that if the project is already marked as `:modified` it's status\ndoes not change to `:affected` since by default modified projects are\nconsidered affected.","ref":"Workspace.Project.html#affected/1"},{"type":"function","title":"Workspace.Project.affected?/1","doc":"Returns `true` if the project is affected, `false` otherwise.\n\nA project is considered `:affected` if it is either modified or indirectly\naffected from a modified dependency.","ref":"Workspace.Project.html#affected?/1"},{"type":"function","title":"Workspace.Project.config/1","doc":"Returns the `Mix.Project` config of the given `mix.exs` file.\n\nThe project will be loaded using `Mix.Project.in_project/4`.","ref":"Workspace.Project.html#config/1"},{"type":"function","title":"Workspace.Project.ensure_mix_file!/1","doc":"Ensures that the given `path` is an existing `mix.exs` file.\n\nIf the file does not exist or the filename is not `mix.exs` it will raise.","ref":"Workspace.Project.html#ensure_mix_file!/1"},{"type":"function","title":"Workspace.Project.format_tag/1","doc":"Formats a tag as a binary.","ref":"Workspace.Project.html#format_tag/1"},{"type":"function","title":"Workspace.Project.has_any_tag?/2","doc":"Returns `true` if the `project` has any of the given tags.","ref":"Workspace.Project.html#has_any_tag?/2"},{"type":"function","title":"Workspace.Project.has_scoped_tag?/2","doc":"Returns `true` if the `project` has at least one scoped tag with the\ngiven `scope`, `false` otherwise.","ref":"Workspace.Project.html#has_scoped_tag?/2"},{"type":"function","title":"Workspace.Project.has_tag?/2","doc":"Returns `true` if the `project` has the given `tag`, `false` otherwise.","ref":"Workspace.Project.html#has_tag?/2"},{"type":"function","title":"Special tags - Workspace.Project.has_tag?/2","doc":"- `:*` - matches all tags, it always returns `true`","ref":"Workspace.Project.html#has_tag?/2-special-tags"},{"type":"function","title":"Workspace.Project.in_project/2","doc":"Runs the given function inside the given project.\n\n`path` can be one of the following:\n\n- a path to a `mix.exs` file\n- a path to a folder containing a `mix.exs` file\n\nBoth absolute and relative paths are supported.\n\nThis function will delegate to `Mix.Project.in_project/4`. The `app` name is\nextracted from the project folder name, so it is expected to match the internal\ndefined `:app` name in `mix.exs`.\n\nThe return value of this function is the return value of `fun`","ref":"Workspace.Project.html#in_project/2"},{"type":"function","title":"Examples - Workspace.Project.in_project/2","doc":"Mix.Project.in_project(\"/path/to/my_app/mix.exs\", fn module -> module end)\n    #=> MyApp.MixProject","ref":"Workspace.Project.html#in_project/2-examples"},{"type":"function","title":"Workspace.Project.modified/2","doc":"Marks the given project as `:modified`.\n\nThe `changes` is the list of changed files belonging to the current\n`project` that have changed.\n\nAn exception will be raised if the `changes` list is empty.","ref":"Workspace.Project.html#modified/2"},{"type":"function","title":"Workspace.Project.modified?/1","doc":"Returns `true` if the project is modified, false otherwise","ref":"Workspace.Project.html#modified?/1"},{"type":"function","title":"Workspace.Project.new/2","doc":"Creates a new project for the given project path.\n\nThe `path` can be one of the following:\n\n- A path to a `mix.exs` file\n- A path to a project containing a `mix.exs` file\n\nYou can pass both absolute and relative paths. All paths will\nbe expanded by default.\n\nThis will raise if the `path` does not correspond to a valid\nmix project.","ref":"Workspace.Project.html#new/2"},{"type":"function","title":"Workspace.Project.project_type/1","doc":"Returns the project type of a project given the mix config.\n\nThe project type is defined under a `:type` attribute in the `:workspace`\nconfig. It can take an arbitrary value. If set to `:workspace` it indicates\nthat the project is a root workspace project.","ref":"Workspace.Project.html#project_type/1"},{"type":"function","title":"Workspace.Project.relative_to_workspace/1","doc":"Relative path of the project to the workspace","ref":"Workspace.Project.html#relative_to_workspace/1"},{"type":"function","title":"Workspace.Project.scoped_tags/2","doc":"Returns all tags with the given `scope`.","ref":"Workspace.Project.html#scoped_tags/2"},{"type":"function","title":"Workspace.Project.set_root/2","doc":"Flags the given `project` as root project or not.","ref":"Workspace.Project.html#set_root/2"},{"type":"function","title":"Workspace.Project.set_status/2","doc":"Sets the status of the given `project`.","ref":"Workspace.Project.html#set_status/2"},{"type":"function","title":"Workspace.Project.skip/1","doc":"Marks the given project as skippable.","ref":"Workspace.Project.html#skip/1"},{"type":"type","title":"Workspace.Project.t/0","doc":"Struct holding info about a mix project","ref":"Workspace.Project.html#t:t/0"},{"type":"type","title":"Workspace.Project.tag/0","doc":"A project's tag.\n\nIt can either be a single atom or a tuple of atoms. In the latter case\nthis is considered a scoped tag.","ref":"Workspace.Project.html#t:tag/0"},{"type":"function","title":"Workspace.Project.to_map/2","doc":"Returns a map including the key properties of the given project.\n\nOnly `:app`, `:module`, `:mix_path`, `:path`, `:workspace_path`, `:status`,\n`:root` and `:changes` are included.","ref":"Workspace.Project.html#to_map/2"},{"type":"function","title":"Options - Workspace.Project.to_map/2","doc":"* `:relative` - If set to `true` the paths will be relative with respect to\nthe workspace path. Notice that the `workspace_path` attribute will be set to\n`\".\"` if `relative` is set.","ref":"Workspace.Project.html#to_map/2-options"},{"type":"module","title":"Workspace.State","doc":"The low-level API and the workspace state struct.","ref":"Workspace.State.html"},{"type":"module","title":"The `%Workspace.State{}` structure - Workspace.State","doc":"Every workspace is stored internally as a struct containing the following\nfields:\n\n  * `:projects` - a map of the form `%{atom => Workspace.Project.t()}` where\n  the key is the defined project name. It includes all detected workspace\n  projects excluding any ignored ones.\n  * `:cwd` - the directory from which the generation of the workspace struct\n  occurred.\n  * `:mix_path` - absolute path to the workspace's root `mix.exs` file.\n  * `:workspace_path` - absolute path of the workspace, this is by default the\n  folder containing the workspace mix file.\n  * `:git_root_path` - the absolute path of the git repository containing the\n  workspace\n  * `:config` - the workspace's configuration, check `Workspace.Config` for\n  more details.","ref":"Workspace.State.html#module-the-workspace-state-structure"},{"type":"function","title":"Workspace.State.new/4","doc":"Initializes a new workspace from the given settings.\n\nIt expects the following:\n\n- `path` is the root path of the workspace\n- `mix_path` is the root mix file, usually a `mix.exs` in the `path`\n- `config` is the workspace configuration\n- `projects` is a list of workspace projects\n\nNotice that *no validation is applied* at this level.","ref":"Workspace.State.html#new/4"},{"type":"type","title":"Workspace.State.t/0","doc":"Struct holding the workspace state.\n\nIt contains the following:\n\n* `:projects` - A map with all workspace projects.\n* `:config` - The workspace configuration settings.\n* `:mix_path` - The path to the workspace's root `mix.exs`.\n* `:workspace_path` - The workspace root path.\n* `:git_root_path` - The git root path, of the repository containing the workspace.\n* `:cwd` - The directory from which the workspace was generated.\n* `:graph` - The DAG (directed acyclic graph) of the workspace.\n* `:status_updated?` - Set to `true` if the workspace status has been updated.","ref":"Workspace.State.html#t:t/0"},{"type":"module","title":"Workspace.Status","doc":"Utilities related to the workspace status.\n\nThe workspace status is defined by the changed files and the\ndependencies between the projects. A workspace project can\nhave one of the following states:\n\n* `:modified` - if any of the project's files has been modified\n* `:affected` - if any of the project's dependencies is modified\n* `:unaffected` - if the project and any of it's dependencies have\nnot been modified.\n\n> #### Git repository {: .info}\n>\n> Notice that it is assumed that `git` is used for the version\n> control of the repository. In any other case the workspace\n> status related functionality will not work.","ref":"Workspace.Status.html"},{"type":"function","title":"Workspace.Status.affected/2","doc":"Returns the affected projects\n\nA project is considered affected if it has changed or any of it's children has\nchanged.","ref":"Workspace.Status.html#affected/2"},{"type":"function","title":"Options - Workspace.Status.affected/2","doc":"* `:base` (`String.t()`) - The base git reference for detecting changed files,\n  if not set only working tree changes will be included.\n  * `:head` (`String.t()`) - The head git reference for detecting changed files. It\n  is used only if `:base` is set.","ref":"Workspace.Status.html#affected/2-options"},{"type":"function","title":"Workspace.Status.changed/2","doc":"Returns the changed files grouped by the project they belong to.","ref":"Workspace.Status.html#changed/2"},{"type":"function","title":"Options - Workspace.Status.changed/2","doc":"* `:base` (`String.t()`) - The base git reference for detecting changed files,\n  if not set only working tree changes will be included.\n  * `:head` (`String.t()`) - The head git reference for detecting changed files. It\n  is used only if `:base` is set.","ref":"Workspace.Status.html#changed/2-options"},{"type":"type","title":"Workspace.Status.file_info/0","doc":"","ref":"Workspace.Status.html#t:file_info/0"},{"type":"function","title":"Workspace.Status.modified/2","doc":"Returns the modified projects\n\nA workspace project is considered modified if any of it's files has\nchanged with respect to the `base` branch.","ref":"Workspace.Status.html#modified/2"},{"type":"function","title":"Options - Workspace.Status.modified/2","doc":"* `:base` (`String.t()`) - The base git reference for detecting changed files,\n  if not set only working tree changes will be included.\n  * `:head` (`String.t()`) - The head git reference for detecting changed files. It\n  is used only if `:base` is set.","ref":"Workspace.Status.html#modified/2-options"},{"type":"function","title":"Workspace.Status.update/2","doc":"Annotates the workspace projects with their statuses.\n\nThis will mark the workspace projects with either `:affected` or\n`:modified` based on the changes between the `:base` and `:head`\nreferences.","ref":"Workspace.Status.html#update/2"},{"type":"function","title":"Options - Workspace.Status.update/2","doc":"* `:base` (`String.t()`) - The base git reference for detecting changed files,\n  if not set only working tree changes will be included.\n  * `:head` (`String.t()`) - The head git reference for detecting changed files. It\n  is used only if `:base` is set.\n  * `:force` (`boolean()`) - If set the workspace status will be force updated.","ref":"Workspace.Status.html#update/2-options"},{"type":"module","title":"Workspace.Topology","doc":"Helper utilities related to the workspace's topology.","ref":"Workspace.Topology.html"},{"type":"function","title":"Workspace.Topology.parent_project/2","doc":"Returns the project the file belongs to, or `nil` in case of error.","ref":"Workspace.Topology.html#parent_project/2"},{"type":"behaviour","title":"Workspace.Check","doc":"A behaviour for implementing workspace check.","ref":"Workspace.Check.html"},{"type":"behaviour","title":"Introduction - Workspace.Check","doc":"A check is responsible for validating that a workspace follows the\nconfigured rules.\n\nWhen your mono-repo grows it is becoming more tedious to keep track with\nall projects and ensure that the same standards apply to all projects. For\nexample you may wish to have common dependencies defined across all your\nprojects, or common `deps` paths.","ref":"Workspace.Check.html#module-introduction"},{"type":"behaviour","title":"Configuration - Workspace.Check","doc":"In order to define a `Workspace.Check` you must add an entry under the `:checks`\nkey of your `Workspace.Config`. The supported options are for each check are:\n\n* `:id` (`t:atom/0`) - A unique identifier for the check.\n\n* `:module` (`t:atom/0`) - Required. The `Workspace.Check` module to be used.\n\n* `:group` - The group of the check. Can be set optionally in order to\n  group checks together in the output of `workspace.check`.\n  All checks that don't have a custom group set will be listed\n  under the default checks group with the order they were\n  defined in your config.\n\n* `:opts` (`t:keyword/0`) - The check's custom options. The default value is `[]`.\n\n* `:description` (`t:String.t/0`) - An optional description of the check\n\n* `:only` (list of `t:atom/0`) - A list of projects. The check will be executed only in the specified projects The default value is `[]`.\n\n* `:ignore` (list of `t:atom/0`) - A list of projects to be ignored from the check The default value is `[]`.\n\n* `:allow_failure` - A list of projects (or `true` for all) that are allowed to fail. In case of\n  a failure it will be logged as a warning but the exit code of check will not\n  be set to 1. The default value is `false`.","ref":"Workspace.Check.html#module-configuration"},{"type":"behaviour","title":"Configuration Examples - Workspace.Check","doc":"```elixir\n[\n  checks: [\n    [\n      module: Workspace.Checks.ValidateConfigPath,\n      description: \"check deps_path\",\n      opts: [\n        config_attribute: :deps_path,\n        expected_path: \"deps\"\n      ]\n    ]\n  ]\n]\n```","ref":"Workspace.Check.html#module-configuration-examples"},{"type":"behaviour","title":"The `Workspace.Check` behaviour - Workspace.Check","doc":"In order to implement and use a custom check you need to:\n\n  1. Define a module implementing the `Workspace.Check` behaviour.\n  2. Include your check in the workspace configuration.","ref":"Workspace.Check.html#module-the-workspace-check-behaviour"},{"type":"behaviour","title":"The schema - Workspace.Check","doc":"Let's implement a simple check that verifies that all workspace projects\nhave a description set.\n\n```elixir\ndefmodule MyCheck do\n  @behaviour Workspace.Check\n\n  # ...callbacks implementation...\nend\n```\n\nWe will start by defining the check's schema. This is expected to be a\n`NimbleOptions` schema with the custom options of your check. For the needs\nof this guide we will assume that we support a single option:\n\n```elixir\n@impl Workspace.Check\ndef schema do\n  schema = [\n    must_end_with_period: [\n      type: :boolean,\n      doc: \"If set the description must end with a period\",\n      default: false\n    ]\n  ]\n\n  NimbleOptions.new!(schema)\nend\n```\n\n> #### Schema as module attribute {: .tip}\n>\n> Instead of defining the schema directly in the `c:schema/0` callback it\n> is advised to define it as a module attribute. This way you can auto-generate\n> documentation in your check's `moduledoc`:\n>\n> ```elixir\n> defmodule MyCheck do\n>   @behaviour Workspace.Check\n>\n>   @schema NimbleOptions.new!(\n>     must_end_with_period: [\n>       type: :boolean,\n>       doc: \"If set the description must end with a period\",\n>       default: false\n>     ] \n>   )\n>\n>   @moduledoc \"\"\"\n>   My check's documentation\n>\n>","ref":"Workspace.Check.html#module-the-schema"},{"type":"behaviour","title":"Options - Workspace.Check","doc":">\n>   #{NimbleOptions.docs(@schema)}\n>   \"\"\"\n> \n>   @impl Workspace.Check\n>   def schema, do: @schema\n> end\n> ```","ref":"Workspace.Check.html#module-options"},{"type":"behaviour","title":"The check - Workspace.Check","doc":"We can now implement the `c:check/2` callback which is responsbible for the\nactual check logic. In our simple example we only need to verify that the\n`:description` is set in each project's config.\n\nThe `c:check/2` callback is expected to return a list of check results. You\ncan use the `check_projects/3` helper method.\n\n```elixir\n@impl Workspace.Check\ndef check(workspace, check) do\n  must_end_with_period = Keyword.fetch!(check[:opts], :must_end_with_period)\n\n  Workspace.Check.check_projects(workspace, check, fn project ->\n    description = project.config[:description]\n\n    cond do\n      not is_binary(description) ->\n        {:error, description: description, message: \"description must be a string\"}\n\n      must_end_with_period and not String.ends_with?(description, \".\") ->\n        {:error, description: description, message: \"description must end with a period\"}\n\n      true ->\n        {:ok, description: description}\n    end\n  end)\nend\n```\n\nNotice that the `check_projects/3` helper expects the inner function to return\n`:ok`, `:error` tuples where the second element is check metadata. These metadata are\nused by the `c:format_result/1` callback for pretty printing the check status\nmessage per project.\n\n```elixir\n@impl Workspace.Check\ndef format_result(%Workspace.Check.Result{status: :ok, meta: metadata}) do\n  \"description set to #{metadata[:description]}\"\nend\n\ndef format_result(%Workspace.Check.Result{status: :error, meta: metadata}) do\n  message = metadata[:message]\n  description = metadata[:description]\n\n  [message, \", got: \", :red, inspect(description), :reset]\nend\n```\n\nNotice how we use `IO.ANSI` escape sequences for pretty printing the invalid\nproject description.\n\nFor more examples you can check the implementation of the checks provided by\nthe workspace.","ref":"Workspace.Check.html#module-the-check"},{"type":"callback","title":"Workspace.Check.check/2","doc":"Applies a workspace check on the given workspace","ref":"Workspace.Check.html#c:check/2"},{"type":"function","title":"Workspace.Check.check_projects/3","doc":"Helper function for running a check on all projects of a workspace.\n\nThe function must return `{:ok, metadata}` or `{:error, metadata}`. It returns\na `Check.Result` for each checked project.\n\nIt takes care of transforming the function output to a `Check.Result` struct\nand handling ignored projects.","ref":"Workspace.Check.html#check_projects/3"},{"type":"callback","title":"Workspace.Check.format_result/1","doc":"Formats a check result for display purposes.","ref":"Workspace.Check.html#c:format_result/1"},{"type":"callback","title":"Workspace.Check.schema/0","doc":"An optional definition of the custom check's options.\n\nIf not set the options will not be validated and all keyword lists will be considered\nvalid. It is advised to define it for better handling of errors.","ref":"Workspace.Check.html#c:schema/0"},{"type":"function","title":"Workspace.Check.validate/1","doc":"Validates that the given `config` is a valid `Check` config.","ref":"Workspace.Check.html#validate/1"},{"type":"module","title":"Workspace.Check.Result","doc":"A struct holding a check's result.\n\nContains info about the checked project if applicable, the check's config\nand the check status and metadata.","ref":"Workspace.Check.Result.html"},{"type":"function","title":"Workspace.Check.Result.new/2","doc":"Initializes a check results struct for the given `check` and `project`","ref":"Workspace.Check.Result.html#new/2"},{"type":"function","title":"Workspace.Check.Result.set_metadata/2","doc":"Sets the result's metadata.","ref":"Workspace.Check.Result.html#set_metadata/2"},{"type":"function","title":"Workspace.Check.Result.set_status/2","doc":"Sets the result's status.","ref":"Workspace.Check.Result.html#set_status/2"},{"type":"type","title":"Workspace.Check.Result.t/0","doc":"The internal representation of a workspace check result.\n\nIt includes the following fields:\n\n* `:module` - the underlying check module implementing the `Workspace.Check` behaviour\n* `:check` - the check configuration\n* `:project` - the `Workspace.Project` on which the check was executed\n* `:status` - the status of the check, will be `:ok` in case of success, `:error` in\ncase of failure or `:skip` if the check was skipped for the current project.\n* `:meta` - arbitrary check metadata","ref":"Workspace.Check.Result.html#t:t/0"},{"type":"module","title":"Workspace.Checks.DependenciesVersion","doc":"Checks that the configured dependencies versions match the expected ones\n\n> #### Common use cases {: .tip}\n>\n> This check can be used in order to ensure common dependencies versions and\n> options across all projects of your mono-repo.","ref":"Workspace.Checks.DependenciesVersion.html"},{"type":"module","title":"Configuration - Workspace.Checks.DependenciesVersion","doc":"* `:deps` (non-empty `t:keyword/0`) - Defines the required dependencies versions across the workspace. Each key\n  corresponds to the name of an external dependency, and the value should be\n  a keyword list which accepts the following options:\n\n  * `:version` (`t:String.t/0` or `t:Keyword.t/0`) - Required. The required version of the package. This can either be a string indicating\n    hex version numbers or a keyword list for git or path dependencies.\n\n  * `:options` (`t:keyword/0`) - Other options of the dependencies definition that should also match. This is\n    useful, in case you want to ensure for example, that specific dependencies are\n    loaded only in the `:dev` environment. In order to do this, you have to set the\n    `:options` to `[only: :dev]`.\n\n    If not set only the version will be checked.","ref":"Workspace.Checks.DependenciesVersion.html#module-configuration"},{"type":"module","title":"Example - Workspace.Checks.DependenciesVersion","doc":"```elixir\n[\n  module: Workspace.Checks.DependenciesVersion,\n  opts: [\n    deps: [\n      # checks version and :only and :runtime options\n      ex_doc: [\n        version: \"== 0.28.3\",\n        options: [only: :dev, runtime: true]\n      ],\n      # checks only version\n      ex_doc: [\n        version: \"== 0.28.3\",\n      ],\n      # checks a git dependency version\n      ex_doc: [\n        version: [github: \"elixir-lang/ex_doc\"]\n      ]\n    ]\n  ]\n]\n```","ref":"Workspace.Checks.DependenciesVersion.html#module-example"},{"type":"module","title":"Workspace.Checks.EnforceBoundaries","doc":"Enforces boundaries between projects.\n\nWorkspace provides a generic mechanism in order to express constraints on project\ndependencies using the defined tags. Using this check you can specify rules about\nwhat internal dependencies are allowed or forbidden.\n\nEach configured check must specify the `:tag` for which it applies and either a\nset of tags that are allowed to depend on or a set of tags that are forbidden.\n\n> #### Common use cases {: .tip}\n>\n> When you start paritioning your codebase into multiple well-defined cohesive\n> packages, even for small projects, dozens of packages will be created. If all\n> of them can depend on each other freely, the workspace will become umanageable\n> and you will end up with a [big ball of mud](https://en.wikipedia.org/wiki/Anti-pattern#Big_ball_of_mud).\n>\n> One of the main purposes of the workspace is to help you split your codebase\n> into independent, cohesive and reusable packages. As a side effect you end up\n> with a **clean architecture**.\n>\n> The main purpose of this rule is to enforce the clean architecture and explicitly\n> declare the allowed cross-workspace dependencies.\n>\n> By properly tagging your projects by the architectural layer they belong to,\n> you can apply rules of the form:\n>\n> * `:shared` libraries can only depend on `:shared` libraries\n> * applications can only depend on the business logic layer\n> * applications are not allowed to depend on data layer packages directly","ref":"Workspace.Checks.EnforceBoundaries.html"},{"type":"module","title":"Configuration - Workspace.Checks.EnforceBoundaries","doc":"* `:tag` - Required. Tag that source project must contain for the rule to be applicable\n\n* `:allowed_tags` - The source project is allowed to depend on projects that contain at least\n  one of these tags. If not set all dependencies are allowed. The default value is `[:*]`.\n\n* `:forbidden_tags` - The source project is forbidden to depend on projects that contain at least\n  one of these tags. If not set all dependencies are allowed. The default value is `[]`.","ref":"Workspace.Checks.EnforceBoundaries.html#module-configuration"},{"type":"module","title":"Example - Workspace.Checks.EnforceBoundaries","doc":"You can enforce allowed dependencies for projects with specific tags. For example\nbelow we enforce that all projects tagged with `{:scope, :shared}` can only depend\non internal projects with the `{:scope, :shared}` tag.\n\n```elixir\n[\n  module: Workspace.Checks.EnforceBoundaries,\n  description: \"shared projects can only depend on shared\",\n  opts: [\n    tag: {:scope, :shared},\n    allowed_tags: [{:scope, :shared}]\n  ]\n]\n```\n\nAdditionally we can forbid specific dependencies, for example:\n\n```elixir\n[\n  module: Workspace.Checks.EnforceBoundaries,\n  description: \"public packages cannot depend on admin packages\",\n  opts: [\n    tag: :public,\n    forbidden_tags: [:admin]\n  ]\n]\n```\n\nBy setting multiple boundaries rules you implicitly define your architecture and\nenforce proper dependencies, making the project more maintainable.\n\n> #### Combination with other checks {: .neutral}\n>\n> It is advised to combine this check with the `Workspace.Checks.ValidateTags` and\n> `Workspace.Checks.RequiredScopeTag` checks in order to:\n>\n> - ensure that all project tags are valid\n> - ensure that all projects are properly scope tagged across the dimensions you\n> have decided to tag upon (`scope`, `team`, `layer` etc)\n> - boundaries are enforced between the various projects","ref":"Workspace.Checks.EnforceBoundaries.html#module-example"},{"type":"module","title":"Workspace.Checks.EnsureDependencies","doc":"Checks that the given dependencies are defined.\n\n> #### Common use case {: .tip}\n>\n> This check can be used to ensure that all projects or a subset of your\n> mono-repo projects have some required dependencies defined.\n> For example you can use it to ensure that all projects depend on `:ex_doc`.\n>\n> This only checks that the dependency is defined, no matter what it's\n> version is. To enforce additionally a specific version you can use\n> `Workspace.Checks.DependenciesVersion`.","ref":"Workspace.Checks.EnsureDependencies.html"},{"type":"module","title":"Configuration - Workspace.Checks.EnsureDependencies","doc":"* `:deps` (list of `t:atom/0`) - Required. The list of required dependencies. An error will be raised if\n  any of these packages is **not** used as a dependency in any\n  workspace project.","ref":"Workspace.Checks.EnsureDependencies.html#module-configuration"},{"type":"module","title":"Example - Workspace.Checks.EnsureDependencies","doc":"In order to ensure that all workspace projects use `:ex_doc` and `:credo`\nadd the following rule in your `workspace.exs`:\n\n```elixir\n[\n  module: Workspace.Checks.EnsureDependencies,\n  opts: [\n    deps: [:ex_doc, :credo]\n  ]\n]\n```","ref":"Workspace.Checks.EnsureDependencies.html#module-example"},{"type":"module","title":"Workspace.Checks.ForbiddenDeps","doc":"Ensures that the given dependencies are not defined.\n\nThis check can be used to ensure that all projects or a subset of your\nmono-repo projects do not have some dependencies defined.\n\n> #### Common use cases {: .tip}\n>\n> A common use case for this check is when you want to deprecate a\n> specific dependency in favor of another one and want to ensure that\n> it is not introduced again in your workspace.","ref":"Workspace.Checks.ForbiddenDeps.html"},{"type":"module","title":"Configuration - Workspace.Checks.ForbiddenDeps","doc":"* `:deps` (list of `t:atom/0`) - Required. The list of forbidden deps. An error will be raised if\n  any of these packages is used as a dependency in any\n  workspace project.","ref":"Workspace.Checks.ForbiddenDeps.html#module-configuration"},{"type":"module","title":"Example - Workspace.Checks.ForbiddenDeps","doc":"The following check ensures that `:foo` and `:bar` are not defined\nas dependencies across the workspace\n\n```elixir\n[\n  module: Workspace.Checks.ForbiddenDeps,\n  description: \":foo and :bar are forbidden deps\",\n  opts: [\n    deps: [:foo, :bar]\n  ]\n]\n```","ref":"Workspace.Checks.ForbiddenDeps.html#module-example"},{"type":"module","title":"Workspace.Checks.RequiredScopeTag","doc":"Checks that the project has at least one scope tag with the given scope.\n\nThis check can be used in order to validate that all (or some) of the workspace\nprojects have at least one tag with the given scope defined. By default it is\nallowed to set only one tag for a scope, but you can override this by setting\nthe `:multiple` option to `true`.\n\n> #### Common use cases {: .tip}\n>\n> A common use case for this check is when you want to use scoped tags for\n> enforcing boundaries or defining the architectural level of each package.\n> In these cases it is a good practice to require all packages to have\n> some specific scope allowed.","ref":"Workspace.Checks.RequiredScopeTag.html"},{"type":"module","title":"Configuration - Workspace.Checks.RequiredScopeTag","doc":"* `:scope` (`t:atom/0`) - Required. The required scope.\n\n* `:multiple` (`t:boolean/0`) - If set to `true` the same scope is allowed to be defined multiple\n  times. If set to `false` (the default) the check will fail if the\n  project has more than one tags with the given scope. The default value is `false`.","ref":"Workspace.Checks.RequiredScopeTag.html#module-configuration"},{"type":"module","title":"Example - Workspace.Checks.RequiredScopeTag","doc":"In order to configure this check add the following, under `checks`, in your workspace\nconfig:\n\n```elixir\n[\n  module: Workspace.Checks.RequiredScopeTag,\n  description: \"all projects must have a {:type, _value} tag set\",\n  opts: [\n    scope: :type   \n  ]\n]\n```","ref":"Workspace.Checks.RequiredScopeTag.html#module-example"},{"type":"module","title":"Workspace.Checks.ValidateConfigPath","doc":"Checks that the given path is properly configured\n\n> #### Common use case {: .tip}\n>\n> This is useful in cases you want to specify a common path for some of\n> your project's artifacts, e.g. `deps_path` or `build_path`. This will\n> check that the configuration option of the given project matches the\n> expected path. Notice that the expected path is always considered to\n> be relative to the project's workspace path.","ref":"Workspace.Checks.ValidateConfigPath.html"},{"type":"module","title":"Configuration - Workspace.Checks.ValidateConfigPath","doc":"* `:config_attribute` - Required. The configuration attribute to check. This can either be a\n  single atom or a list of atoms for nested config options.\n\n* `:expected_path` - Relative path with respect to the workspace root. This\n  can either be a relative path with respect to workspace root or an\n  anonymous function taking as input a `Workspace.Project` and returning\n  a dynamic expected path.","ref":"Workspace.Checks.ValidateConfigPath.html#module-configuration"},{"type":"module","title":"Example - Workspace.Checks.ValidateConfigPath","doc":"In order to configure this check add the following, under `checks`,\nin your `.workspace.exs`:\n\n```elixir\n[\n  module: Workspace.Checks.ValidateConfigPath,\n  description: \"all projects must have a common dependencies path\",\n  opts: [\n    config_attribute: :deps_path,\n    expected_path: \"artifacts/deps\"\n  ]\n]\n```","ref":"Workspace.Checks.ValidateConfigPath.html#module-example"},{"type":"module","title":"Workspace.Checks.ValidateProject","doc":"Checks that the given project is valid\n\nThis is a generic check since you can define any arbitrary check for\nthe given project.\n\nIt expects an anonymous of arity 1 to be provided that will accept a `Workspace.Project`\nas input. \n\n> #### Common use cases {: .tip}\n>\n> This check can be used to verify any high level setting of your Mix projects\n> like:\n>\n> - Ensure that the test coverage threshold is above a limit\n> - A package maintainer is defined\n> - All projects have a description set","ref":"Workspace.Checks.ValidateProject.html"},{"type":"module","title":"Configuration - Workspace.Checks.ValidateProject","doc":"* `:validate` (function of arity 1) - Required. An anonymous function of arity 1 for validating a workspace project. The project's\n  struct is passed as input to the user provided function. It must return one of:\n\n  - `{:ok, message :: String.t()}` in case of success\n  - `{:error, message :: String.t()}` in case of error","ref":"Workspace.Checks.ValidateProject.html#module-configuration"},{"type":"module","title":"Example - Workspace.Checks.ValidateProject","doc":"In order to configure this check add the following, under `checks`,\nin your `.workspace.exs`:\n\n```elixir\n[\n  module: Workspace.Checks.ValidateProject,\n  description: \"all projects must have elixir version set to 1.13\",\n  opts: [\n    validate: fn config ->\n      case config[:elixir] do\n        \"~> 1.13\" -> {:ok, \"elixir version set to 1.13\"}\n        other -> {:error, \"wrong elixir version, expected 1.13, got #{other}\"}\n      end\n    end\n  ]\n]\n```","ref":"Workspace.Checks.ValidateProject.html#module-example"},{"type":"module","title":"Workspace.Checks.ValidateTags","doc":"Checks that the project's tags are valid.\n\nThis check can be used in order to limit the possible tags assigned to each project\nto a well defined set of allowed values.","ref":"Workspace.Checks.ValidateTags.html"},{"type":"module","title":"Configuration - Workspace.Checks.ValidateTags","doc":"* `:allowed` - Required. A list of allowed tags. A tag can either be a single `atom` or a\n  scoped tag of the form `{atom, atom}`.","ref":"Workspace.Checks.ValidateTags.html#module-configuration"},{"type":"module","title":"Example - Workspace.Checks.ValidateTags","doc":"In order to configure this check add the following, under `checks`, in your workspace\nconfig:\n\n```elixir\n[\n  module: Workspace.Checks.ValidateTags,\n  description: \"all projects must adhere to our tags policy\",\n  opts: [\n    allowed: [\n      :shared,\n      :app,\n      :ui,\n      {:importance, :critical},\n      {:importance, :low}  \n    ]\n  ]\n]\n```","ref":"Workspace.Checks.ValidateTags.html#module-example"},{"type":"module","title":"Workspace.Checks.WorkspaceDepsPaths","doc":"Checks that the relative paths of workspace dependencies are valid.\n\n> #### Common use case {: .tip}\n>\n> Since workspace supports arbitraty nested paths, it is a common operation to\n> move around workspace projects. This sanity check will validate that all relative\n> paths are valid without having to compile the whole workspace.","ref":"Workspace.Checks.WorkspaceDepsPaths.html"},{"type":"module","title":"Example - Workspace.Checks.WorkspaceDepsPaths","doc":"In order to enable the check add the following to your `.workspace.exs`\n\n```elixir\n[\n  module: Workspace.Checks.WorkspaceDepsPaths,\n  description: \"validate workspace relative path dependencies\"\n]\n```","ref":"Workspace.Checks.WorkspaceDepsPaths.html#module-example"},{"type":"module","title":"Workspace.Cli","doc":"Helper functions for the mix tasks","ref":"Workspace.Cli.html"},{"type":"function","title":"Workspace.Cli.debug/1","doc":"Prints a debug message.\n\nThe message is printed only if debugging messages are enabled. In  order to\nenable them you need to set the `WORKSPACE_DEV` environment variable to\n`\"true\"`.","ref":"Workspace.Cli.html#debug/1"},{"type":"function","title":"Workspace.Cli.format/2","doc":"Format the data and apply any custom styling\n\nIt will return an `ansidata` list with the styling applied. Notice\nthat if `emit?` is set to false, ANSI escape sequences are not emitted.\n\nAn exception will be raised if an ANSI sequence is invalid.\n\nThe returned list may still contain atoms. These will be handled by the\n`IO.ANSI.format` when the message is printed.","ref":"Workspace.Cli.html#format/2"},{"type":"function","title":"Examples - Workspace.Cli.format/2","doc":"iex> Workspace.Cli.format(\"Hello\")\n    [[], \"Hello\"]\n\n    iex> Workspace.Cli.format(:red)\n    [[], :red]\n\n    iex> Workspace.Cli.format(:red, false)\n    []\n\n    iex> Workspace.Cli.format([:affected, \"project\", :reset])\n    [[[[], [[[], \"\u001B[38;5;179m\"], :bright]], \"project\"], :reset]\n\n    iex> Workspace.Cli.format(:invalid, false)\n    ** (ArgumentError) invalid ANSI sequence specification: :invalid","ref":"Workspace.Cli.html#format/2-examples"},{"type":"function","title":"Workspace.Cli.highlight/2","doc":"Highlights the given `text` with the given ansi codes\n\nThis helper just wraps the `text` with the given ansi codes and\nadds a `:reset` afterwards.","ref":"Workspace.Cli.html#highlight/2"},{"type":"function","title":"Examples - Workspace.Cli.highlight/2","doc":"iex> Workspace.Cli.highlight(\"a blue text\", :blue)\n    [:blue, [\"a blue text\"], :reset]\n\n    iex> Workspace.Cli.highlight([\"some \", \"text\"], :blue)\n    [:blue, [\"some \", \"text\"], :reset]\n\n    iex> Workspace.Cli.highlight(\"some text\", [:bright, :green])\n    [:bright, :green, [\"some text\"], :reset]","ref":"Workspace.Cli.html#highlight/2-examples"},{"type":"function","title":"Workspace.Cli.hl/2","doc":"Highlights the given string based on it's type.\n\nThe following types are currently supported:\n\n* `:code` - highlighted with `:light_cyan`","ref":"Workspace.Cli.html#hl/2"},{"type":"function","title":"Workspace.Cli.log/2","doc":"Helper function for console log messages\n\nThe message can be a rich formatted list. On top of the default elixir\nstyles, various `workspace` related styles are supported for consistency\nacross the cli apps. For more details on the supported style specifications\ncheck `format_style/1`.","ref":"Workspace.Cli.html#log/2"},{"type":"function","title":"Options - Workspace.Cli.log/2","doc":"- `:prefix` the prefix to be used. You can either specify the actual header\nor set one of the following options:\n  - `:header`: corresponds to \"==> \".\n  - if set to `false` no prefix is applied.\n  - if not set then no prefix is applied.","ref":"Workspace.Cli.html#log/2-options"},{"type":"function","title":"Workspace.Cli.log_with_title/3","doc":"Helper function for logging a message with a title\n\nEach log message consists of the following sections:\n\n- `prefix` a prefix for each log message, defaults to \"==> \". Can be\nconfigured through the `prefix` option. If set to `false` no prefix\nis applied.\n- `title` a string representing the title of the log message, e.g.\nan application name, a command or a log level. \n- `separator` separator between the title and the main message, defaults\nto a space.\n- `message` the message to be printed, can be any text","ref":"Workspace.Cli.html#log_with_title/3"},{"type":"function","title":"Options - Workspace.Cli.log_with_title/3","doc":"- `:prefix` - the prefix to be used, defaults to `==> `\n- `:separator` - the separator to be used between title and message, defaults\nto ` - `","ref":"Workspace.Cli.html#log_with_title/3-options"},{"type":"function","title":"Examples - Workspace.Cli.log_with_title/3","doc":"You can combine it with other helper CLI functions like `highlight` for\nrich text log messages.\n\n```elixir\n# Default invocation\nCli.log(\":foo\", \"a message\") ##> ==> :foo - a message\n\n# with a different prefix\nCli.log(\":foo\", \"a message\", prefix: \"> \") ##> > :foo - a message\n\n# with highlighted sections\nCli.log(project_name(project, show_status: true), highlight(message, [:bright, :red]))\n```","ref":"Workspace.Cli.html#log_with_title/3-examples"},{"type":"function","title":"Workspace.Cli.options/2","doc":"Merges the common options with the extra","ref":"Workspace.Cli.html#options/2"},{"type":"function","title":"Workspace.Cli.project_name/2","doc":"Format the project name with the default styling and status info if needed.","ref":"Workspace.Cli.html#project_name/2"},{"type":"function","title":"Options - Workspace.Cli.project_name/2","doc":"* `:show_status` - if set to `true` it color codes the name based on the status\nof the project and appends status icons as following:\n  * `:modified` - `✚` (bright red)\n  * `:affected` - `●` (bright yellow)\n  * `:unaffected` - `✔` (:bright green)\n* `:default_style` - can be used to change the default style (`:light_cyan`)","ref":"Workspace.Cli.html#project_name/2-options"},{"type":"function","title":"Workspace.Cli.status_color/1","doc":"Returns the color code for the given status.","ref":"Workspace.Cli.html#status_color/1"},{"type":"module","title":"Workspace.Export","doc":"Helper utilities for exporting the workspace to various formats.","ref":"Workspace.Export.html"},{"type":"function","title":"Workspace.Export.run_results_to_json/1","doc":"Returns a `json` representation of the given run results.","ref":"Workspace.Export.html#run_results_to_json/1"},{"type":"function","title":"Workspace.Export.to_json/2","doc":"Returns a `json` representation of the key workspace properties.\n\nBy default only the `workspace_path` and the `projects` are included.","ref":"Workspace.Export.html#to_json/2"},{"type":"function","title":"Options - Workspace.Export.to_json/2","doc":"* `:sort` - if set to `true` projects will be sorted alphabetically. Defaults to\n`false`.\n* `:relative` - if paths will be relative or absolute. If set to `true` then\n`workspace_path` will be set to `\".\"`. Defaults to `false`.\n\nNotice that skipped projects are not included.","ref":"Workspace.Export.html#to_json/2-options"},{"type":"module","title":"Workspace.Git","doc":"Helper git related functions","ref":"Workspace.Git.html"},{"type":"type","title":"Workspace.Git.change_type/0","doc":"","ref":"Workspace.Git.html#t:change_type/0"},{"type":"function","title":"Workspace.Git.changed/1","doc":"Detects the changed files in the given directory.\n\nBy default the following files are included:\n\n  - Uncommitted files in the working directory\n  - Untracked files in the working directory\n  - If `:base` is provided it also includes:\n    - The changed files between `:base` and `HEAD` if no `:head` is set.\n    - The changed files between `:base` and `:head` if `:head` is set.\n\nA list of tuples of the form `{\"path/to/changed/file\", change_type}` is\nreturned, where `change_type` can be one of the following:\n\n* `:uncommitted` - for changed files under version control that are not committed\n* `:untracked` - for new files that are not under version control\n* `:modified` - for changed committed files between the `HEAD` and the `BASE`","ref":"Workspace.Git.html#changed/1"},{"type":"function","title":"Options - Workspace.Git.changed/1","doc":"* `:cd` (`t:binary/0`) - The git repo path, defaults to the current working directory.\n  * `:base` (`t:binary/0`) - The base reference to use for comparing to the `HEAD`,\n  can be a branch, a commit or any other `git` reference.\n  * `:head` (`t:binary/0`) - The `head` to use for comparing to `:base`, if not set\n  defaults to `HEAD`. Can be any git reference","ref":"Workspace.Git.html#changed/1-options"},{"type":"function","title":"Workspace.Git.changed_files/3","doc":"Get changed files between the given `head` and `base` git references.","ref":"Workspace.Git.html#changed_files/3"},{"type":"function","title":"Options - Workspace.Git.changed_files/3","doc":"* `:cd` (`t:binary/0`) - The git repo path, defaults to the current working directory.","ref":"Workspace.Git.html#changed_files/3-options"},{"type":"function","title":"Workspace.Git.root/1","doc":"Get the git repo root of the given path\n\nReturns `{:ok, path}` in case of success or `{:error, reason}` in\ncase of failure.","ref":"Workspace.Git.html#root/1"},{"type":"function","title":"Options - Workspace.Git.root/1","doc":"* `:cd` - the path to use for getting the git root, if not\nset defaults to the current working directory.","ref":"Workspace.Git.html#root/1-options"},{"type":"function","title":"Workspace.Git.uncommitted_files/1","doc":"Returns a list of uncommitted files\n\nUncommitted are considered the files that are staged but not committed yet.","ref":"Workspace.Git.html#uncommitted_files/1"},{"type":"function","title":"Options - Workspace.Git.uncommitted_files/1","doc":"* `:cd` (`t:binary/0`) - The git repo path, defaults to the current working directory.","ref":"Workspace.Git.html#uncommitted_files/1-options"},{"type":"function","title":"Workspace.Git.untracked_files/1","doc":"Get list of untracked files","ref":"Workspace.Git.html#untracked_files/1"},{"type":"function","title":"Options - Workspace.Git.untracked_files/1","doc":"* `:cd` (`t:binary/0`) - The git repo path, defaults to the current working directory.","ref":"Workspace.Git.html#untracked_files/1-options"},{"type":"behaviour","title":"Workspace.Coverage.Exporter","doc":"The coverage exporter behaviour.","ref":"Workspace.Coverage.Exporter.html"},{"type":"callback","title":"Workspace.Coverage.Exporter.export/3","doc":"Export the given coverage data.\n\nTODO: add detailed docs","ref":"Workspace.Coverage.Exporter.html#c:export/3"},{"type":"module","title":"Workspace.Coverage.LCOV","doc":"[`lcov`](https://github.com/linux-test-project/lcov) coverage exporter.\n\n> #### Using `lcov` with `genhtml` {: .tip}\n>\n> You can combine the `lcov` exporter, with the `genhtml` command in order\n> to generate an `HTML` coverage report for your complete workspace codebase.\n>\n> From the workspace `Makefile`:\n>\n> ```\n> .PHONY: coverage\n> coverage:","ref":"Workspace.Coverage.LCOV.html"},{"type":"module","title":"Generates coverage report - Workspace.Coverage.LCOV","doc":">   mix workspace.run -t test -- --cover\n>   mix workspace.test.coverage\n>   genhtml artifacts/coverage/lcoverage.lcov -o artifacts/coverage --prefic ${PWD}\n> ```","ref":"Workspace.Coverage.LCOV.html#module-generates-coverage-report"},{"type":"module","title":"Options - Workspace.Coverage.LCOV","doc":"The following options are supported:\n\n* `:filename` - the `.lcov` filename, defaults to `coverage.lcov`\n* `:output_path` - the output path, defaults to `cover` under the current directory","ref":"Workspace.Coverage.LCOV.html#module-options"},{"type":"module","title":"Usage - Workspace.Coverage.LCOV","doc":"In order to enable `LCOV` coverage exporter you can add the following\nto your workspace's `:test_coverage, :exporters` config:\n\n    test_coverage: [\n      exporters: [\n        lcov: fn workspace, coverage_stats ->\n          Workspace.Coverage.LCOV.export(workspace, coverage_stats,\n            output_path: \"artifacts/coverage\"\n          )\n        end\n      ]\n    ]","ref":"Workspace.Coverage.LCOV.html#module-usage"},{"type":"module","title":"Workspace.Test","doc":"Convenience helper functions for workspace tests.","ref":"Workspace.Test.html"},{"type":"function","title":"Workspace.Test.assert_captured/3","doc":"Asserts that the captured cli output matches the expected value with respect to\nthe given options.\n\nThis helper assertion function provides some conveniences for working with cli output assertions.","ref":"Workspace.Test.html#assert_captured/3"},{"type":"function","title":"Options - Workspace.Test.assert_captured/3","doc":"- `:trim_trailing_newlines` - if set trailing newlines are ignored.\n- `:trim_whitespace` - if set either leading or trailing whitespace is ignored from\neach line of the output.\n- `:trim_leading` - if set leading whitespace is ignored from each line of the output.\n- `:trim_trailing` - if set trailing whitespace is ignored from each line of the output.\n\nIf no option is set a strict equality check is performed.\n\nNotice that all trimming operations (if needed) will happen both on the captured,\nand expected strings.","ref":"Workspace.Test.html#assert_captured/3-options"},{"type":"function","title":"Workspace.Test.commit_changes/1","doc":"Creates a git commit with all current changes in the given path.\n\nThis is a helper function for testing that creates a commit with the message \"changes\"\nafter staging all modifications.","ref":"Workspace.Test.html#commit_changes/1"},{"type":"function","title":"Examples - Workspace.Test.commit_changes/1","doc":"commit_changes(\"path/to/workspace\")","ref":"Workspace.Test.html#commit_changes/1-examples"},{"type":"function","title":"Workspace.Test.create_mix_project/5","doc":"Creates a mix project fixture under the given workspace path.\n\nThe `path` is expected to be the relative path with respect to the `workspace_path` where\nthe project will be located.\n\nYou can pass either a project config which will be merged with some default settings\nand persisted, or directly the contents of the mix file. Notice that in the latter case\n`app` is not used.\n\nFor example by calling:\n\n    create_mix_project(\"path/to/workspace\", :foo, \"packages/foo\", [description: \"The foo project\"])\n\nwill write the following to `path/to/workspace/packages/foo/mix.exs`:\n\n    defmodule Foo.MixProject do\n      use Mix.Project\n\n      def project do\n        [\n          app: :foo,\n          elixir: \"~> 1.14\",\n          start_permanent: false,\n          elixirc_paths: [],\n          description: \"The foo project\"\n        ]\n      end\n    end","ref":"Workspace.Test.html#create_mix_project/5"},{"type":"function","title":"Options - Workspace.Test.create_mix_project/5","doc":"* `:formatter` - Whether to add a default `.formatter.exs`, defaults to `true`\n* `:lib_folder` - Whether to create an empty `lib` sub folder, defaults to `true`","ref":"Workspace.Test.html#create_mix_project/5-options"},{"type":"function","title":"Workspace.Test.create_workspace/4","doc":"Creates a workspace fixture at the given path.\n\nIt expects a workspace path, configuration, and either a predefined fixture or a list of projects\nto be created.\n\nRaises an `ArgumentError` if the workspace path is not empty","ref":"Workspace.Test.html#create_workspace/4"},{"type":"function","title":"Options - Workspace.Test.create_workspace/4","doc":"* `:projects` - Additional project configuration to merge, defaults to `[]`. This is useful if you want to update\nthe project configuration of a default fixture. For example in order to add a description to the `package_a` project\nyou can do:\n\n      create_workspace(\"path/to/workspace\", [], :default,\n        projects: [package_a: [description: \"Package A\"]]\n      )\n\n* `:workspace_module` - Optional name for the workspace module fixture. If not set defaults to `TestWorkspace`","ref":"Workspace.Test.html#create_workspace/4-options"},{"type":"function","title":"Examples - Workspace.Test.create_workspace/4","doc":"# Using default fixture\n    create_workspace(\"tmp/test_workspace\", [], :default)\n\n    # Using custom projects\n    create_workspace(\"tmp/test_workspace\", [], [\n      {:app_a, \"packages/app_a\", [description: \"App A\"]},\n      {:app_b, \"packages/app_b\", [deps: [{:app_a, path: \"../app_a\"}]]}\n    ])","ref":"Workspace.Test.html#create_workspace/4-examples"},{"type":"function","title":"Workspace.Test.in_fixture/2","doc":"Runs the given test function unloading at the end any module or package initialized\nfrom within the given `path`.\n\n`path` is considered to be the fixture path. Any module that will be loaded during the\n`test_fn` execution will be purged and deleted at the end.\n\nIt is advised to use this on any test that requires a fixture, in order to avoid\nwarnings about redefining packages.","ref":"Workspace.Test.html#in_fixture/2"},{"type":"function","title":"Workspace.Test.init_git_project/1","doc":"Initializes a git repository in the given path.\n\nCreates an initial commit with all files in the path and sets the default branch to `main`.","ref":"Workspace.Test.html#init_git_project/1"},{"type":"function","title":"Examples - Workspace.Test.init_git_project/1","doc":"init_git_project(\"path/to/workspace\")","ref":"Workspace.Test.html#init_git_project/1-examples"},{"type":"function","title":"Workspace.Test.modify_project/3","doc":"Simulates a modification to a project in the workspace by creating a dummy file.\n\nCreates an empty file at `lib/file.ex` in the specified project path to simulate\nproject modifications. This is useful for testing workspace change detection.\n\nRaises an `ArgumentError` if the project path does not exist","ref":"Workspace.Test.html#modify_project/3"},{"type":"function","title":"Options - Workspace.Test.modify_project/3","doc":"* `:file` - The relative path of the file with respect of the project dir to be\nadded. Defaults to `lib/file.ex`","ref":"Workspace.Test.html#modify_project/3-options"},{"type":"function","title":"Examples - Workspace.Test.modify_project/3","doc":"modify_project(\"/path/to/workspace\", \"packages/foo\")","ref":"Workspace.Test.html#modify_project/3-examples"},{"type":"type","title":"Workspace.Test.project_fixture/0","doc":"","ref":"Workspace.Test.html#t:project_fixture/0"},{"type":"function","title":"Workspace.Test.project_fixture/4","doc":"Creates a **virtual** fixture for a mix project.\n\nIt expects the `app` name, a `path` relative to the workspace which indicates\nthe project's location and a project config.\n\nTests using this function can be safely executed in `async` mode.","ref":"Workspace.Test.html#project_fixture/4"},{"type":"function","title":"Options - Workspace.Test.project_fixture/4","doc":"* `workspace_path` - The absolute workspace path to which this project belongs.\nIf not set defaults to `/usr/local/workspace`.","ref":"Workspace.Test.html#project_fixture/4-options"},{"type":"function","title":"Examples - Workspace.Test.project_fixture/4","doc":"iex> Workspace.Test.project_fixture(:foo, \"packages/foo\", [description: \"the foo package\"])\n    %Workspace.Project{\n      app: :foo,\n      module: :\"Foo.MixProject\",\n      config: [description: \"the foo package\", app: :foo],\n      mix_path: \"/usr/local/workspace/packages/foo/mix.exs\",\n      path: \"/usr/local/workspace/packages/foo\",\n      workspace_path: \"/usr/local/workspace\",\n      skip: false,\n      status: :undefined,\n      root?: nil,\n      changes: nil,\n      tags: []\n    }\n\nNotice that if `path` is not a relative path an exception will be raised.\n\n> #### Virtual fixture {: .warning}\n>\n> Notice that this creates an in-memory virtual fixture. This means that the underlying mix\n> project does not exist and is not loaded.\n>\n> If you want to test something on an actual project you should use the `with_workspace/5`\n> instead which generates the actual fixtures and loads them in memory.","ref":"Workspace.Test.html#project_fixture/4-examples"},{"type":"function","title":"Workspace.Test.with_workspace/5","doc":"Runs the given `test_fn` in a temporary workspace under the given `path`.\n\nYou can pass a predefined fixture or a list of projects to be created. Check `create_workspace/4` for more details.","ref":"Workspace.Test.html#with_workspace/5"},{"type":"function","title":"Options - Workspace.Test.with_workspace/5","doc":"* `:projects` - Additional project configuration to merge, defaults to `[]`. This is useful if you want to update\nthe project configuration of a default fixture. For example in order to add a description to the `package_a` project\nyou can do:\n\n      with_workspace(\n        \"tmp/test_workspace\", [], :default,\n        fn ->\n          # test code here\n        end,\n        projects: [package_a: [description: \"Package A\"]]\n      )\n\n* `:cd` - Whether to change directory to the workspace path, defaults to `false`\n* `:git` - Whether to initialize the workspace as a git repository, defaults to `false`","ref":"Workspace.Test.html#with_workspace/5-options"},{"type":"function","title":"Cleanup - Workspace.Test.with_workspace/5","doc":"The fixture directory is automatically removed after the test function completes.\nUse `create_workspace/4` directly if you need to preserve the workspace for multiple tests.","ref":"Workspace.Test.html#with_workspace/5-cleanup"},{"type":"function","title":"Examples - Workspace.Test.with_workspace/5","doc":"# Using default fixture\n    with_workspace(\"tmp/test_workspace\", [], :default, fn ->\n      # Test code here\n    end)\n\n    # Using custom projects\n    with_workspace(\"tmp/test_workspace\", [], [\n      {:app_a, \"packages/app_a\", [description: \"App A\"]},\n      {:app_b, \"packages/app_b\", [deps: [{:app_a, path: \"../app_a\"}]]}\n    ], fn ->\n      # Test code here\n    end, git: true)","ref":"Workspace.Test.html#with_workspace/5-examples"},{"type":"function","title":"Workspace.Test.workspace_fixture/2","doc":"Generates a **virtual** workspace fixture.\n\nIt expects one of the following:\n\n* A list of `Workspace.Project` structs.\n* A list of tuples of the form, `{app, path, config}` which will be used for generating\nproject fixtures (see `project_fixture/4` for more details)\n* An atom representing a default fixture.\n\n> #### Virtual fixture {: .warning}\n>\n> Notice that this creates an in-memory virtual fixture. This means that the underlying mix\n> projects do not exist and are not loaded.\n>\n> If you want to test something on an actual project you should use the `with_workspace/5`\n> instead which generates the actual fixtures and loads them in memory.","ref":"Workspace.Test.html#workspace_fixture/2"},{"type":"function","title":"Options - Workspace.Test.workspace_fixture/2","doc":"* `workspace_path` - The absolute workspace path to which this project belongs.\nIf not set defaults to `/usr/local/workspace`.","ref":"Workspace.Test.html#workspace_fixture/2-options"},{"type":"extras","title":"Overview","doc":"# Workspace\n\n[![Hex.pm](https://img.shields.io/hexpm/v/workspace.svg)](https://hex.pm/packages/workspace)\n[![hex.pm](https://img.shields.io/hexpm/l/workspace.svg)](https://hex.pm/packages/workspace)\n[![hex.pm](https://img.shields.io/hexpm/dt/workspace.svg)](https://hex.pm/packages/workspace)\n[![Documentation](https://img.shields.io/badge/-Documentation-blueviolet)](https://hexdocs.pm/workspace/index.html)\n\n`Workspace` provides a set of tools for working with **elixir monorepos**.\n\n> #### What is a monorepo? {: .neutral}\n>\n> **A monorepo is a single repository containing multiple distinct projects.**\n>\n> In a monorepo setup, all related application, libraries, and tools, are housed\n> together, allowing developers to manage and version control them collectively.\n\nMonorepos on big codebases offer several potential benefits:\n\n  * **Code Sharing** - Developers can easily share code and components across\n  projects within the same repository, promoting code reuse and reducing duplication.\n  * **Consistent Versioning** - All components in the monorepo can share the same\n  versioning scheme, ensuring consistency and compatibility.\n  * **Simplified Dependency Management** - Since all dependencies are managed\n  within a single repository, dependency management can be more straightforward\n  compared to managing dependencies across multiple repositories.\n  * **Streamlined Build and Continuous Integration** - With all code in one place,\n  build processes and continuous integration (CI) pipelines can be more efficient,\n  as changes to any part of the codebase can trigger only the CI steps **affected\n  by this change**. Additionally any change to any component is immediately tested\n  across all packages using the modified component.\n  * **Improved Collaboration** - Developers can more easily collaborate on different\n  parts of the system since all code is accessible within the same repository.\n  * **Modular Design and Architectural Consistency** - With all related projects and\n  components housed together, developers are incentivized to create modular, reusable\n  code that adheres to consistent architectural patterns. This promotes better\n  design practices and helps maintain a cohesive architecture across the entire\n  codebase.","ref":"readme.html"},{"type":"extras","title":"Overview - Overview","doc":"`Workspace` provides a set of tools for working with multiple projects under\nthe same git repo. Using path dependencies between the projects and the\nprovided tools you can effectively work on massive codebases properly\nsplit into reusable packages.","ref":"readme.html#overview"},{"type":"extras","title":"Core features - Overview","doc":"The core features of `Workspace` are:\n\n  * **Non intrusive** - zero dependencies for your elixir projects.\n  * **Run tasks efficiently** - includes a `mix workspace.run` command for\n  orchestrating where each task will be executed; test only affected projects\n  by a change, format only modified projects, or partition your executions,\n  reducing significantly CI times.\n  * **Enforced boundaries** - tag your projects and enforce boundaries\n  between projects, facilitating architectural consistency.\n  * **Consistency Checks** - includes a `mix workspace.check` command\n  for linting your workspace; ensure that all projects have the same versions\n  of external dependencies, or that all projects have valid maintainers.\n  * **Arbitrary folder structure** - you can create your projects wherever you\n  wish under the workspace root, no assumptions are made.","ref":"readme.html#core-features"},{"type":"extras","title":"The workspace folder structure - Overview","doc":"A workspace is a normal `Mix.Project` with some tweaks:\n\n  * No actual code is expected, so `:elixirc_paths` is set to `[]`.\n  * It must have a `:workspace` project option configured with a `:type` set\n  to `:workspace`.\n  * You can have as many mix projects as you wish in any folder\n  structure under the root.\n  * You must use **path dependencies between workspace projects** similarly\n  to umbrellas.","ref":"readme.html#the-workspace-folder-structure"},{"type":"extras","title":"Creating a workspace - Overview","doc":"The easiest way to create a workspace, is to use the `workspace_new` installer.\nAssuming you have elixir installed, install the archive by running:\n\n```bash\n$ mix archive.install hex workspace_new\n```\n\nNow you can generate your workspace by running:\n\n```bash\n$ mix workspace.new my_workspace\n```\n\nThis will scaffold an empty workspace project under `$PWD/my_workspace`. You can\nnow start adding mix projects as usual under this root folder.","ref":"readme.html#creating-a-workspace"},{"type":"extras","title":"The workspace graph - Overview","doc":"The central concept of the `Workspace` is the workspace graph. This is a directed\nacyclic graph where each vertex is a workspace project and each edge a dependency\nbetween two workspace projects.\n\nYou can view the graph of your workspace with the `mix workspace.graph` command:\n\n```bash\n$ mix workspace.graph --show-status\n:api ●\n├── :accounts ✔\n│   └── :ecto_utils ✔\n├── :cli_tools ✔\n└── :orders ✚\n    ├── :string_utils ✔\n    └── :warehouse ✔\n        └── :ecto_utils ✔\n:back_office ✔\n└── :cli_tools ✔\n```\n\n> #### Project's status {: .info}\n>\n> Notice the `--show-status` flag above. `Workspace` detects the changes on your\n> git repository and determined which projects are `modified` and which ones are\n> `affected` by the changes.\n>\n> This way you can limit the execution of a task to the relevant projects.\n>\n> See also `mix workspace.status`.\n>\n> ![workspace.status example](https://github.com/sportradar/elixir-workspace/raw/assets/status.gif)\n\nYou can also output the graph as a `mermaid` chart:\n\n```mermaid\nflowchart TD\n  accounts\n  api\n  back_office\n  cli_tools\n  ecto_utils\n  orders\n  string_utils\n  warehouse\n\n  accounts --> ecto_utils\n  api --> accounts\n  api --> cli_tools\n  api --> orders\n  back_office --> cli_tools\n  orders --> string_utils\n  orders --> warehouse\n  warehouse --> ecto_utils\n\n  classDef external fill:#999,color:#ee0;\n\n  class api affected;\n  class orders modified;\n\n  classDef affected fill:#FA6,color:#FFF;\n  classDef modified fill:#F33,color:#FFF;\n```","ref":"readme.html#the-workspace-graph"},{"type":"extras","title":"Running tasks on projects - Overview","doc":"Monorepos can have hundreds of projects, so being able to run actions against\nall (or some) of them is a key feature of `Workspace`.\n\n![workspace.run example](https://github.com/sportradar/elixir-workspace/raw/assets/run.gif)\n\n`mix workspace.run` allows you to:\n\n  * Run a task against all or a subset of projects.\n  * Run tasks only on projects based on their status and workspace graph topology.\n  * Filter projects based on tags.\n  * Partitioning runs for parallelizing CI steps.\n\nFor example:\n\n```bash\n# Run mix deps.get on all workspace projects\n$ mix workspace.run -t deps.get\n\n# Run mix docs only on cli_tools\n$ mix workspace.run -t docs -p cli_tools\n\n# Run mix test on all affected projects\n$ mix workspace.run -t test --affected\n\n# Run mix format on all modified projects\n$ mix workspace.run -t format --modified\n\n# Run mix compile only on top level projects\n$ mix workspace.run -t compile --only-roots -- --warnings-as-errors\n```\n\nCheck the `mix workspace.run` docs for more details.","ref":"readme.html#running-tasks-on-projects"},{"type":"extras","title":"Workspace checks - Overview","doc":"When your mono-repo grows it is becoming more tedious to keep track with\nall projects and ensure that the same standards apply to all projects. For\nexample you may wish to have common dependencies defined across all your\nprojects, or specific conventions for the various artifacts output folders.\n\nAll checks implement the `Workspace.Check` behaviour and can be configured\nin your `.workspace.exs` file. `Workspace` comes with some default checks\nthat among other, allow you to:\n\n  * Ensure that [specific dependencies are set](https://hexdocs.pm/workspace/Workspace.Checks.EnsureDependencies.html)\n  on all projects, e.g. `ex_doc`.\n  * Ensure that external [dependencies versions match the expected ones](https://hexdocs.pm/workspace/Workspace.Checks.DependenciesVersion.html).\n  * Verify that [no forbidden dependencies are defined](https://hexdocs.pm/workspace/Workspace.Checks.ForbiddenDeps.html).\n  * [Validate arbitrarily](https://hexdocs.pm/workspace/Workspace.Checks.ValidateProject.html)\n  the projects' config objects.\n  * [Enforce boundaries](https://hexdocs.pm/workspace/Workspace.Checks.EnforceBoundaries.html)\n  between workspace projects.\n\nYou can also implement your own checks, incorporating any custom validation\nlogic you may wish.\n\nYou can run the checks against your workspace through the `mix workspace.check`\ncommand:\n\n```bash\n$ mix workspace.check\nrunning 4 workspace checks on the workspace\n\n==> C000 validate workspace relative path dependencies\n==> C001 all projects must have a description set\nERROR :accounts - no :description set packages/accounts\n==> C002 forbidden dependencies are not used\nERROR :ecto_utils - the following forbidden dependencies were detected: [:poison] packages/ecto_utils\n==> C003 strict external dependencies\nERROR :string_utils - version mismatches for the following dependencies: [:ex_doc]\n    → :ex_doc expected \"== 0.28.3\" \"== 0.30.0\" packages/string_utils\n```","ref":"readme.html#workspace-checks"},{"type":"extras","title":"Installation - Overview","doc":"If you want to manually create the workspace root project and not you the\n`:workspace_new` scaffolding tool, then you need to add `workspace` as a\ntop level dependency:\n\n```elixir\ndef deps do\n  [\n    {:workspace, \"~> 0.2.0\"}\n  ]\nend\n```\n\nand also indicate that the current project is a `workspace`:\n\n```elixir\ndef project do\n[\n  workspace: [\n    type: :workspace,\n    # arbitrary options can be set there\n  ],\n  # rest Mix.Project settings\n]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"License - Overview","doc":"Copyright (c) 2023 Panagiotis Nezis, Sportradar\n\nWorkspace is released under the MIT License. See the [LICENSE](LICENSE) file for more\ndetails.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/).\n\n## [v0.2.2](https://github.com/sportradar/elixir-workspace/tree/workspace/v0.2.2) (2025-07-10)","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"* `workspace.run`: store task output in the exported `json`.\n\n* `workspace.run`: include the task duration in milliseconds in the exported `json`.\n\n* `workspace.list`: support `--base`, `--head`, `--affected` and `---modified` options.\n\n* `workspace.test.coverage`: allow filtering by package path.\n\n## [v0.2.1](https://github.com/sportradar/elixir-workspace/tree/workspace/v0.2.1) (2025-03-14)\n\n* Allow having multiple workspaces under the same git repo.\n\n## [v0.2.0](https://github.com/sportradar/elixir-workspace/tree/workspace/v0.2.0) (2025-02-07)\n\n**This version requires at least elixir v1.16**","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"* `workspace.run`: support specifying execution order through the `--option` flag.\n\n  Till now `workspace.run` was executing the tasks in alphabetical order. A new `--order`\n  cli option is added that support setting it to `preorder`. This will perform a\n  depth first search on the project graph and return the projects in post-order, e.g.\n  outer leaves are returned first respecting the topology of your workspace.\n\n* `workspace.run`: support filtering by root paths through the `--path` flag.\n\n* `workspace.run`: support filtering by `--dependency` and `--dependent` similarly\nto `workspace.list`.\n\n* Support passing most repeated CLI arguments as a comma separated list, for\n  example you can now do:\n\n  ```bash\n  $ mix workspace.run -t format -p p1,p2,p3\n  ```\n\n* `workspace.check`: support running specific checks through the `--check` option\n* `workspace.check`: support grouping checks.\n\n  You can now configure the group of each check in your workspace config, with the\n  `group` option. Checks with the same group will be printed together on the CLI output,\n  under a group header.\n\n  Additionally you can specify `groups_for_checks` with which you can modify the default\n  look and feel of each check group, for example:\n\n  ```elixir\n  groups_for_checks: [\n    package: [\n      style: [:light_blue_background, :black],\n      title: \" 📦 Package checks\"\n    ],\n    documentation: [\n      style: [:yellow_background, :black],\n      title: \" 📚 Documentation checks\"\n    ]\n  ]\n  ```\n\n* `workspace.list`: support filtering by root paths through the `--path` flag.\n\n* Promoted helper testing utilities to a `Workspace.Test` module.","ref":"changelog.html#added"},{"type":"extras","title":"Deprecated - Changelog","doc":"* Check definitions without an `id` is deprecated. ids can be used for filtering\n  the checks that will be executed.","ref":"changelog.html#deprecated"},{"type":"extras","title":"Removed - Changelog","doc":"* `Workspace.Utils.Path.relative_to/2` has been removed. After requiring at least\nelixir 1.16 you can now use `Path.relative_to/3` instead with the `force: true`\noption.","ref":"changelog.html#removed"},{"type":"extras","title":"Fixed - Changelog","doc":"* Escape base and head references in git commands.\n\n* `workspace.test.coverage`: respect `ignore_modules` from coverage report\n\n## [v0.1.2](https://github.com/sportradar/elixir-workspace/tree/workspace/v0.1.2) (2024-09-30)","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"* `workspace.list`: support filtering by dependents through the `--dependent` flag. You\ncan now list all projects that are direct dependencies of a given project:\n\n  ```bash\n  mix workspace.list --dependent my_project\n  ```\n\n* `workspace.list`: support filtering by dependencies through the `--dependency`. Using this\nflag you can list only those projects that have the given direct dependency:\n\n  ```bash\n  mix workspace.list --dependency a_project\n  ```\n\n* `workspace.list`: add `--maintainer` for filtering projects with the given maintainer\n\n## [v0.1.1](https://github.com/sportradar/elixir-workspace/tree/workspace/v0.1.1) (2024-07-04)","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"* `workspace.run`: add `--export` option for exporting execution results as a `json`\nfile\n* `workspace.run`: log execution time per project\n* `workspace.list`: add `--relative-paths` option for exporting relative paths with\nrespect to the workspace path instead of absolute paths (the default one).","ref":"changelog.html#added"},{"type":"extras","title":"Removed - Changelog","doc":"* `workspace.run`: remove `--execution-mode` flag\n\n## [v0.1.0](https://github.com/sportradar/elixir-workspace/tree/workspace/v0.1.0) (2024-05-13)\n\nInitial release.","ref":"changelog.html#removed"},{"type":"extras","title":"License","doc":"# MIT License\n\nCopyright (c) 2023 Panagiotis Nezis, Sportradar\n\nPermission is hereby granted, free of charge, to any person obtaining\na copy of this software and associated documentation files (the\n\"Software\"), to deal in the Software without restriction, including\nwithout limitation the rights to use, copy, modify, merge, publish,\ndistribute, sublicense, and/or sell copies of the Software, and to\npermit persons to whom the Software is furnished to do so, subject to\nthe following conditions:\n\nThe above copyright notice and this permission notice shall be\nincluded in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND,\nEXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF\nMERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND\nNONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE\nLIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION\nOF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION\nWITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}